   PROGRAM



   INCLUDE('ABERROR.INC'),ONCE
   INCLUDE('ABFILE.INC'),ONCE
   INCLUDE('ABUTIL.INC'),ONCE
   INCLUDE('ERRORS.CLW'),ONCE
   INCLUDE('KEYCODES.CLW'),ONCE
   INCLUDE('ABFUZZY.INC'),ONCE

   MAP
     MODULE('FIREBIRD_BC.CLW')
DctInit     PROCEDURE                                      ! Initializes the dictionary definition module
DctKill     PROCEDURE                                      ! Kills the dictionary definition module
     END
!--- Application Global and Exported Procedure Definitions --------------------------------------------
     MODULE('FIREBIRD001.CLW')
Main                   PROCEDURE   !Wizard Application for D:\dev\C7.2\Firebird\Firebird.dct
     END
   END

SilentRunning        BYTE(0)                               ! Set true when application is running in 'silent mode'

!region File Declaration
COUNTRY              FILE,DRIVER('ODBC'),OWNER('ClarionMagFirebird'),NAME('COUNTRY'),PRE(COU),BINDABLE,THREAD !                    
INTEG_2                  KEY(COU:COUNTRY),PRIMARY          !                    
Record                   RECORD,PRE()
COUNTRY                     CSTRING(16)                    !                    
CURRENCY                    CSTRING(11)                    !                    
                         END
                     END                       

CUSTOMER             FILE,DRIVER('ODBC'),OWNER('ClarionMagFirebird'),NAME('CUSTOMER'),PRE(CUS),BINDABLE,THREAD !                    
CUSTNAMEX                KEY(CUS:CUSTOMER),DUP             !                    
CUSTREGION               KEY(CUS:COUNTRY,CUS:CITY),DUP     !                    
INTEG_61                 KEY(CUS:COUNTRY),DUP              !                    
INTEG_60                 KEY(CUS:CUST_NO),PRIMARY          !                    
Record                   RECORD,PRE()
CUST_NO                     LONG,NAME('"CUST_NO"')         !                    
CUSTOMER                    CSTRING(26)                    !                    
CONTACT_FIRST               CSTRING(16),NAME('"CONTACT_FIRST"') !                    
CONTACT_LAST                CSTRING(21),NAME('"CONTACT_LAST"') !                    
PHONE_NO                    CSTRING(21),NAME('"PHONE_NO"') !                    
ADDRESS_LINE1               CSTRING(31),NAME('"ADDRESS_LINE1"') !                    
ADDRESS_LINE2               CSTRING(31),NAME('"ADDRESS_LINE2"') !                    
CITY                        CSTRING(26)                    !                    
STATE_PROVINCE              CSTRING(16),NAME('"STATE_PROVINCE"') !                    
COUNTRY                     CSTRING(16)                    !                    
POSTAL_CODE                 CSTRING(13),NAME('"POSTAL_CODE"') !                    
ON_HOLD                     STRING(1),NAME('"ON_HOLD"')    !                    
                         END
                     END                       

DEPARTMENT           FILE,DRIVER('ODBC'),OWNER('ClarionMagFirebird'),NAME('DEPARTMENT'),PRE(DEP),BINDABLE,THREAD !                    
BUDGETX                  KEY(-DEP:BUDGET),DUP              !                    
INTEG_31                 KEY(DEP:MNGR_NO),DUP              !                    
INTEG_17                 KEY(DEP:HEAD_DEPT),DUP            !                    
INTEG_16                 KEY(DEP:DEPT_NO),PRIMARY          !                    
RDB_4                    KEY(DEP:DEPARTMENT),NAME('RDB$4') !                    
Record                   RECORD,PRE()
DEPT_NO                     STRING(3),NAME('"DEPT_NO"')    !                    
DEPARTMENT                  CSTRING(26)                    !                    
HEAD_DEPT                   STRING(3),NAME('"HEAD_DEPT"')  !                    
MNGR_NO                     SHORT,NAME('"MNGR_NO"')        !                    
BUDGET                      DECIMAL(12,2)                  !                    
LOCATION                    CSTRING(16)                    !                    
PHONE_NO                    CSTRING(21),NAME('"PHONE_NO"') !                    
                         END
                     END                       

EMPLOYEE             FILE,DRIVER('ODBC'),OWNER('ClarionMagFirebird'),NAME('EMPLOYEE'),PRE(EMP),BINDABLE,THREAD !                    
NAMEX                    KEY(EMP:LAST_NAME,EMP:FIRST_NAME),DUP !                    
INTEG_28                 KEY(EMP:DEPT_NO),DUP              !                    
INTEG_29                 KEY(EMP:JOB_CODE,EMP:JOB_GRADE,EMP:JOB_COUNTRY),DUP !                    
INTEG_27                 KEY(EMP:EMP_NO),PRIMARY           !                    
Record                   RECORD,PRE()
EMP_NO                      SHORT,NAME('"EMP_NO"')         !                    
FIRST_NAME                  CSTRING(16),NAME('"FIRST_NAME"') !                    
LAST_NAME                   CSTRING(21),NAME('"LAST_NAME"') !                    
PHONE_EXT                   CSTRING(5),NAME('"PHONE_EXT"') !                    
HIRE_DATE                   STRING(8),NAME('"HIRE_DATE"')  !                    
HIRE_DATE_GROUP             GROUP,OVER(HIRE_DATE)          !                    
HIRE_DATE_DATE                DATE                         !                    
HIRE_DATE_TIME                TIME                         !                    
                            END                            !                    
DEPT_NO                     STRING(3),NAME('"DEPT_NO"')    !                    
JOB_CODE                    CSTRING(6),NAME('"JOB_CODE"')  !                    
JOB_GRADE                   SHORT,NAME('"JOB_GRADE"')      !                    
JOB_COUNTRY                 CSTRING(16),NAME('"JOB_COUNTRY"') !                    
SALARY                      PDECIMAL(10,2)                 !                    
FULL_NAME                   CSTRING(38),NAME('"FULL_NAME"') !                    
                         END
                     END                       

EMPLOYEE_PROJECT     FILE,DRIVER('ODBC'),OWNER('ClarionMagFirebird'),NAME('"EMPLOYEE_PROJECT"'),PRE(EMP2),BINDABLE,THREAD !                    
INTEG_40                 KEY(EMP2:EMP_NO),DUP              !                    
INTEG_41                 KEY(EMP2:PROJ_ID),DUP             !                    
INTEG_39                 KEY(EMP2:EMP_NO,EMP2:PROJ_ID),PRIMARY !                    
Record                   RECORD,PRE()
EMP_NO                      SHORT,NAME('"EMP_NO"')         !                    
PROJ_ID                     STRING(5),NAME('"PROJ_ID"')    !                    
                         END
                     END                       

JOB                  FILE,DRIVER('ODBC'),OWNER('ClarionMagFirebird'),NAME('JOB'),PRE(JOB),BINDABLE,THREAD !                    
MAXSALX                  KEY(-JOB:JOB_COUNTRY,-JOB:MAX_SALARY),DUP !                    
MINSALX                  KEY(JOB:JOB_COUNTRY,JOB:MIN_SALARY),DUP !                    
INTEG_11                 KEY(JOB:JOB_COUNTRY),DUP          !                    
INTEG_10                 KEY(JOB:JOB_CODE,JOB:JOB_GRADE,JOB:JOB_COUNTRY),PRIMARY !                    
JOB_REQUIREMENT             BLOB,NAME('"JOB_REQUIREMENT"') !                    
Record                   RECORD,PRE()
JOB_CODE                    CSTRING(6),NAME('"JOB_CODE"')  !                    
JOB_GRADE                   SHORT,NAME('"JOB_GRADE"')      !                    
JOB_COUNTRY                 CSTRING(16),NAME('"JOB_COUNTRY"') !                    
JOB_TITLE                   CSTRING(26),NAME('"JOB_TITLE"') !                    
MIN_SALARY                  PDECIMAL(10,2),NAME('"MIN_SALARY"') !                    
MAX_SALARY                  PDECIMAL(10,2),NAME('"MAX_SALARY"') !                    
LANGUAGE_REQ                CSTRING(92),NAME('"LANGUAGE_REQ"') !                    
                         END
                     END                       

PHONE_LIST           FILE,DRIVER('ODBC'),OWNER('ClarionMagFirebird'),NAME('"PHONE_LIST"'),PRE(PHO),BINDABLE,THREAD !                    
Record                   RECORD,PRE()
EMP_NO                      SHORT,NAME('"EMP_NO"')         !                    
FIRST_NAME                  CSTRING(16),NAME('"FIRST_NAME"') !                    
LAST_NAME                   CSTRING(21),NAME('"LAST_NAME"') !                    
PHONE_EXT                   CSTRING(5),NAME('"PHONE_EXT"') !                    
LOCATION                    CSTRING(16)                    !                    
PHONE_NO                    CSTRING(21),NAME('"PHONE_NO"') !                    
                         END
                     END                       

PROJECT              FILE,DRIVER('ODBC'),OWNER('ClarionMagFirebird'),NAME('PROJECT'),PRE(PRO),BINDABLE,THREAD !                    
INTEG_36                 KEY(PRO:TEAM_LEADER),DUP          !                    
PRODTYPEX                KEY(PRO:PRODUCT,PRO:PROJ_NAME)    !                    
INTEG_35                 KEY(PRO:PROJ_ID),PRIMARY          !                    
RDB_11                   KEY(PRO:PROJ_NAME),NAME('RDB$11') !                    
PROJ_DESC                   BLOB,NAME('"PROJ_DESC"')       !                    
Record                   RECORD,PRE()
PROJ_ID                     STRING(5),NAME('"PROJ_ID"')    !                    
PROJ_NAME                   CSTRING(21),NAME('"PROJ_NAME"') !                    
TEAM_LEADER                 SHORT,NAME('"TEAM_LEADER"')    !                    
PRODUCT                     CSTRING(13)                    !                    
                         END
                     END                       

PROJ_DEPT_BUDGET     FILE,DRIVER('ODBC'),OWNER('ClarionMagFirebird'),NAME('"PROJ_DEPT_BUDGET"'),PRE(PRO2),BINDABLE,THREAD !                    
INTEG_47                 KEY(PRO2:DEPT_NO),DUP             !                    
INTEG_48                 KEY(PRO2:PROJ_ID),DUP             !                    
INTEG_46                 KEY(PRO2:FISCAL_YEAR,PRO2:PROJ_ID,PRO2:DEPT_NO),PRIMARY !                    
Record                   RECORD,PRE()
FISCAL_YEAR                 LONG,NAME('"FISCAL_YEAR"')     !                    
PROJ_ID                     STRING(5),NAME('"PROJ_ID"')    !                    
DEPT_NO                     STRING(3),NAME('"DEPT_NO"')    !                    
QUART_HEAD_CNT              CSTRING(46),NAME('"QUART_HEAD_CNT"') !                    
PROJECTED_BUDGET            DECIMAL(12,2),NAME('"PROJECTED_BUDGET"') !                    
                         END
                     END                       

SALARY_HISTORY       FILE,DRIVER('ODBC'),OWNER('ClarionMagFirebird'),NAME('"SALARY_HISTORY"'),PRE(SAL),BINDABLE,THREAD !                    
CHANGEX                  KEY(-SAL:CHANGE_DATE),DUP         !                    
UPDATERX                 KEY(SAL:UPDATER_ID),DUP           !                    
INTEG_56                 KEY(SAL:EMP_NO),DUP               !                    
INTEG_55                 KEY(SAL:EMP_NO,SAL:CHANGE_DATE,SAL:UPDATER_ID),PRIMARY !                    
Record                   RECORD,PRE()
EMP_NO                      SHORT,NAME('"EMP_NO"')         !                    
CHANGE_DATE                 STRING(8),NAME('"CHANGE_DATE"') !                    
CHANGE_DATE_GROUP           GROUP,OVER(CHANGE_DATE)        !                    
CHANGE_DATE_DATE              DATE                         !                    
CHANGE_DATE_TIME              TIME                         !                    
                            END                            !                    
UPDATER_ID                  CSTRING(21),NAME('"UPDATER_ID"') !                    
OLD_SALARY                  PDECIMAL(10,2),NAME('"OLD_SALARY"') !                    
PERCENT_CHANGE              REAL,NAME('"PERCENT_CHANGE"')  !                    
NEW_SALARY                  REAL,NAME('"NEW_SALARY"')      !                    
                         END
                     END                       

SALES                FILE,DRIVER('ODBC'),OWNER('ClarionMagFirebird'),NAME('SALES'),PRE(SAL2),BINDABLE,THREAD !                    
NEEDX                    KEY(SAL2:DATE_NEEDED),DUP         !                    
QTYX                     KEY(-SAL2:ITEM_TYPE,-SAL2:QTY_ORDERED),DUP !                    
SALESTATX                KEY(SAL2:ORDER_STATUS,SAL2:PAID),DUP !                    
INTEG_77                 KEY(SAL2:CUST_NO),DUP             !                    
INTEG_78                 KEY(SAL2:SALES_REP),DUP           !                    
INTEG_76                 KEY(SAL2:PO_NUMBER),PRIMARY       !                    
Record                   RECORD,PRE()
PO_NUMBER                   STRING(8),NAME('"PO_NUMBER"')  !                    
CUST_NO                     LONG,NAME('"CUST_NO"')         !                    
SALES_REP                   SHORT,NAME('"SALES_REP"')      !                    
ORDER_STATUS                CSTRING(8),NAME('"ORDER_STATUS"') !                    
ORDER_DATE                  STRING(8),NAME('"ORDER_DATE"') !                    
ORDER_DATE_GROUP            GROUP,OVER(ORDER_DATE)         !                    
ORDER_DATE_DATE               DATE                         !                    
ORDER_DATE_TIME               TIME                         !                    
                            END                            !                    
SHIP_DATE                   STRING(8),NAME('"SHIP_DATE"')  !                    
SHIP_DATE_GROUP             GROUP,OVER(SHIP_DATE)          !                    
SHIP_DATE_DATE                DATE                         !                    
SHIP_DATE_TIME                TIME                         !                    
                            END                            !                    
DATE_NEEDED                 STRING(8),NAME('"DATE_NEEDED"') !                    
DATE_NEEDED_GROUP           GROUP,OVER(DATE_NEEDED)        !                    
DATE_NEEDED_DATE              DATE                         !                    
DATE_NEEDED_TIME              TIME                         !                    
                            END                            !                    
PAID                        STRING(1)                      !                    
QTY_ORDERED                 LONG,NAME('"QTY_ORDERED"')     !                    
TOTAL_VALUE                 DECIMAL(9,2),NAME('"TOTAL_VALUE"') !                    
DISCOUNT                    SREAL                          !                    
ITEM_TYPE                   CSTRING(13),NAME('"ITEM_TYPE"') !                    
AGED                        PDECIMAL(18,9)                 !                    
                         END
                     END                       

DEPARTMENT2          FILE,DRIVER('ODBC'),OWNER('ClarionMagFirebird'),NAME('DEPARTMENT'),PRE(DEP1),BINDABLE,THREAD !                    
BUDGETX                  KEY(-DEP1:BUDGET),DUP             !                    
INTEG_31                 KEY(DEP1:MNGR_NO),DUP             !                    
INTEG_17                 KEY(DEP1:HEAD_DEPT),DUP           !                    
INTEG_16                 KEY(DEP1:DEPT_NO),PRIMARY         !                    
RDB_4                    KEY(DEP1:DEPARTMENT),NAME('RDB$4') !                    
Record                   RECORD,PRE()
DEPT_NO                     STRING(3),NAME('"DEPT_NO"')    !                    
DEPARTMENT                  CSTRING(26)                    !                    
HEAD_DEPT                   STRING(3),NAME('"HEAD_DEPT"')  !                    
MNGR_NO                     SHORT,NAME('"MNGR_NO"')        !                    
BUDGET                      DECIMAL(12,2)                  !                    
LOCATION                    CSTRING(16)                    !                    
PHONE_NO                    CSTRING(21),NAME('"PHONE_NO"') !                    
                         END
                     END                       

DEPARTMENT3          FILE,DRIVER('ODBC'),OWNER('ClarionMagFirebird'),NAME('EMPLOYEE'),PRE(DEP2),BINDABLE,THREAD !                    
NAMEX                    KEY(DEP2:LAST_NAME,DEP2:FIRST_NAME),DUP !                    
INTEG_28                 KEY(DEP2:DEPT_NO),DUP             !                    
INTEG_29                 KEY(DEP2:JOB_CODE,DEP2:JOB_GRADE,DEP2:JOB_COUNTRY),DUP !                    
INTEG_27                 KEY(DEP2:EMP_NO),PRIMARY          !                    
Record                   RECORD,PRE()
EMP_NO                      SHORT,NAME('"EMP_NO"')         !                    
FIRST_NAME                  CSTRING(16),NAME('"FIRST_NAME"') !                    
LAST_NAME                   CSTRING(21),NAME('"LAST_NAME"') !                    
PHONE_EXT                   CSTRING(5),NAME('"PHONE_EXT"') !                    
HIRE_DATE                   STRING(8),NAME('"HIRE_DATE"')  !                    
HIRE_DATE_GROUP             GROUP,OVER(HIRE_DATE)          !                    
HIRE_DATE_DATE                DATE                         !                    
HIRE_DATE_TIME                TIME                         !                    
                            END                            !                    
DEPT_NO                     STRING(3),NAME('"DEPT_NO"')    !                    
JOB_CODE                    CSTRING(6),NAME('"JOB_CODE"')  !                    
JOB_GRADE                   SHORT,NAME('"JOB_GRADE"')      !                    
JOB_COUNTRY                 CSTRING(16),NAME('"JOB_COUNTRY"') !                    
SALARY                      PDECIMAL(10,2)                 !                    
FULL_NAME                   CSTRING(38),NAME('"FULL_NAME"') !                    
                         END
                     END                       

!endregion

Access:COUNTRY       &FileManager,THREAD                   ! FileManager for COUNTRY
Relate:COUNTRY       &RelationManager,THREAD               ! RelationManager for COUNTRY
Access:CUSTOMER      &FileManager,THREAD                   ! FileManager for CUSTOMER
Relate:CUSTOMER      &RelationManager,THREAD               ! RelationManager for CUSTOMER
Access:DEPARTMENT    &FileManager,THREAD                   ! FileManager for DEPARTMENT
Relate:DEPARTMENT    &RelationManager,THREAD               ! RelationManager for DEPARTMENT
Access:EMPLOYEE      &FileManager,THREAD                   ! FileManager for EMPLOYEE
Relate:EMPLOYEE      &RelationManager,THREAD               ! RelationManager for EMPLOYEE
Access:EMPLOYEE_PROJECT &FileManager,THREAD                ! FileManager for EMPLOYEE_PROJECT
Relate:EMPLOYEE_PROJECT &RelationManager,THREAD            ! RelationManager for EMPLOYEE_PROJECT
Access:JOB           &FileManager,THREAD                   ! FileManager for JOB
Relate:JOB           &RelationManager,THREAD               ! RelationManager for JOB
Access:PHONE_LIST    &FileManager,THREAD                   ! FileManager for PHONE_LIST
Relate:PHONE_LIST    &RelationManager,THREAD               ! RelationManager for PHONE_LIST
Access:PROJECT       &FileManager,THREAD                   ! FileManager for PROJECT
Relate:PROJECT       &RelationManager,THREAD               ! RelationManager for PROJECT
Access:PROJ_DEPT_BUDGET &FileManager,THREAD                ! FileManager for PROJ_DEPT_BUDGET
Relate:PROJ_DEPT_BUDGET &RelationManager,THREAD            ! RelationManager for PROJ_DEPT_BUDGET
Access:SALARY_HISTORY &FileManager,THREAD                  ! FileManager for SALARY_HISTORY
Relate:SALARY_HISTORY &RelationManager,THREAD              ! RelationManager for SALARY_HISTORY
Access:SALES         &FileManager,THREAD                   ! FileManager for SALES
Relate:SALES         &RelationManager,THREAD               ! RelationManager for SALES
Access:DEPARTMENT2   &FileManager,THREAD                   ! FileManager for DEPARTMENT2
Relate:DEPARTMENT2   &RelationManager,THREAD               ! RelationManager for DEPARTMENT2
Access:DEPARTMENT3   &FileManager,THREAD                   ! FileManager for DEPARTMENT3
Relate:DEPARTMENT3   &RelationManager,THREAD               ! RelationManager for DEPARTMENT3

FuzzyMatcher         FuzzyClass                            ! Global fuzzy matcher
GlobalErrorStatus    ErrorStatusClass,THREAD
GlobalErrors         ErrorClass                            ! Global error manager
INIMgr               INIClass                              ! Global non-volatile storage manager
GlobalRequest        BYTE(0),THREAD                        ! Set when a browse calls a form, to let it know action to perform
GlobalResponse       BYTE(0),THREAD                        ! Set to the response from the form
VCRRequest           LONG(0),THREAD                        ! Set to the request from the VCR buttons

Dictionary           CLASS,THREAD
Construct              PROCEDURE
Destruct               PROCEDURE
                     END


  CODE
  GlobalErrors.Init(GlobalErrorStatus)
  FuzzyMatcher.Init                                        ! Initilaize the browse 'fuzzy matcher'
  FuzzyMatcher.SetOption(MatchOption:NoCase, 1)            ! Configure case matching
  FuzzyMatcher.SetOption(MatchOption:WordOnly, 0)          ! Configure 'word only' matching
  INIMgr.Init('.\Firebird.INI', NVD_INI)                   ! Configure INIManager to use INI file
  DctInit
  Main
  INIMgr.Update
  INIMgr.Kill                                              ! Destroy INI manager
  FuzzyMatcher.Kill                                        ! Destroy fuzzy matcher


Dictionary.Construct PROCEDURE

  CODE
  IF THREAD()<>1
     DctInit()
  END


Dictionary.Destruct PROCEDURE

  CODE
  DctKill()

