

   MEMBER('Firebird.clw')                                  ! This is a MEMBER module


   INCLUDE('ABBROWSE.INC'),ONCE
   INCLUDE('ABPOPUP.INC'),ONCE
   INCLUDE('ABRESIZE.INC'),ONCE
   INCLUDE('ABTOOLBA.INC'),ONCE
   INCLUDE('ABWINDOW.INC'),ONCE

                     MAP
                       INCLUDE('FIREBIRD003.INC'),ONCE        !Local module procedure declarations
                       INCLUDE('FIREBIRD002.INC'),ONCE        !Req'd for module callout resolution
                     END


!!! <summary>
!!! Generated from procedure template - Window
!!! Select a DEPARTMENT Record
!!! </summary>
SelectDEPARTMENT PROCEDURE 

CurrentTab           STRING(80)                            !
BRW1::View:Browse    VIEW(DEPARTMENT)
                       PROJECT(DEP:DEPT_NO)
                       PROJECT(DEP:DEPARTMENT)
                       PROJECT(DEP:HEAD_DEPT)
                       PROJECT(DEP:MNGR_NO)
                       PROJECT(DEP:BUDGET)
                       PROJECT(DEP:LOCATION)
                       PROJECT(DEP:PHONE_NO)
                     END
Queue:Browse:1       QUEUE                            !Queue declaration for browse/combo box using ?Browse:1
DEP:DEPT_NO            LIKE(DEP:DEPT_NO)              !List box control field - type derived from field
DEP:DEPARTMENT         LIKE(DEP:DEPARTMENT)           !List box control field - type derived from field
DEP:HEAD_DEPT          LIKE(DEP:HEAD_DEPT)            !List box control field - type derived from field
DEP:MNGR_NO            LIKE(DEP:MNGR_NO)              !List box control field - type derived from field
DEP:BUDGET             LIKE(DEP:BUDGET)               !List box control field - type derived from field
DEP:LOCATION           LIKE(DEP:LOCATION)             !List box control field - type derived from field
DEP:PHONE_NO           LIKE(DEP:PHONE_NO)             !List box control field - type derived from field
Mark                   BYTE                           !Entry's marked status
ViewPosition           STRING(1024)                   !Entry's view position
                     END
QuickWindow          WINDOW('Select a DEPARTMENT Record'),AT(,,358,198),FONT('MS Sans Serif',8,,FONT:regular,CHARSET:DEFAULT), |
  RESIZE,CENTER,GRAY,IMM,MDI,HLP('SelectDEPARTMENT'),SYSTEM
                       LIST,AT(8,30,342,124),USE(?Browse:1),HVSCROLL,FORMAT('32L(2)|M~DEPT NO~L(2)@s3@80L(2)|M' & |
  '~DEPARTMENT~L(2)@s25@40L(2)|M~HEAD DEPT~L(2)@s3@36R(2)|M~MNGR NO~C(0)@n-7@76D(32)|M~' & |
  'BUDGET~C(0)@n-17.2@64L(2)|M~LOCATION~L(2)@s15@80L(2)|M~PHONE NO~L(2)@s20@'),FROM(Queue:Browse:1), |
  IMM,MSG('Browsing the DEPARTMENT file')
                       BUTTON('&Select'),AT(301,158,49,14),USE(?Select:2),LEFT,ICON('WASELECT.ICO'),FLAT,MSG('Select the Record'), |
  TIP('Select the Record')
                       SHEET,AT(4,4,350,172),USE(?CurrentTab)
                         TAB('&1) BUDGETX'),USE(?Tab:2)
                         END
                         TAB('&2) INTEG_31'),USE(?Tab:3)
                         END
                         TAB('&3) INTEG_17'),USE(?Tab:4)
                         END
                         TAB('&4) INTEG_16'),USE(?Tab:5)
                         END
                         TAB('&5) RDB_4'),USE(?Tab:6)
                         END
                       END
                       BUTTON('&Close'),AT(252,180,49,14),USE(?Close),LEFT,ICON('WACLOSE.ICO'),FLAT,MSG('Close Window'), |
  TIP('Close Window')
                       BUTTON('&Help'),AT(305,180,49,14),USE(?Help),LEFT,ICON('WAHELP.ICO'),FLAT,MSG('See Help Window'), |
  STD(STD:Help),TIP('See Help Window')
                     END

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass
BRW1                 CLASS(BrowseClass)                    ! Browse using ?Browse:1
Q                      &Queue:Browse:1                !Reference to browse queue
Init                   PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)
ResetSort              PROCEDURE(BYTE Force),BYTE,PROC,DERIVED
                     END

BRW1::Sort0:Locator  StepLocatorClass                      ! Default Locator
BRW1::Sort1:Locator  StepLocatorClass                      ! Conditional Locator - CHOICE(?CurrentTab) = 2
BRW1::Sort2:Locator  StepLocatorClass                      ! Conditional Locator - CHOICE(?CurrentTab) = 3
BRW1::Sort3:Locator  StepLocatorClass                      ! Conditional Locator - CHOICE(?CurrentTab) = 4
BRW1::Sort4:Locator  StepLocatorClass                      ! Conditional Locator - CHOICE(?CurrentTab) = 5
Resizer              CLASS(WindowResizeClass)
Init                   PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)
                     END


  CODE
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------

ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('SelectDEPARTMENT')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?Browse:1
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  BIND('DEP:DEPT_NO',DEP:DEPT_NO)                          ! Added by: BrowseBox(ABC)
  BIND('DEP:HEAD_DEPT',DEP:HEAD_DEPT)                      ! Added by: BrowseBox(ABC)
  BIND('DEP:MNGR_NO',DEP:MNGR_NO)                          ! Added by: BrowseBox(ABC)
  BIND('DEP:PHONE_NO',DEP:PHONE_NO)                        ! Added by: BrowseBox(ABC)
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  IF SELF.Request = SelectRecord
     SELF.AddItem(?Close,RequestCancelled)                 ! Add the close control to the window manger
  ELSE
     SELF.AddItem(?Close,RequestCompleted)                 ! Add the close control to the window manger
  END
  Relate:DEPARTMENT.Open                                   ! File DEPARTMENT used by this procedure, so make sure it's RelationManager is open
  SELF.FilesOpened = True
  BRW1.Init(?Browse:1,Queue:Browse:1.ViewPosition,BRW1::View:Browse,Queue:Browse:1,Relate:DEPARTMENT,SELF) ! Initialize the browse manager
  SELF.Open(QuickWindow)                                   ! Open window
  Do DefineListboxStyle
  BRW1.Q &= Queue:Browse:1
  BRW1.RetainRow = 0
  BRW1.AddSortOrder(,DEP:INTEG_31)                         ! Add the sort order for DEP:INTEG_31 for sort order 1
  BRW1.AddLocator(BRW1::Sort1:Locator)                     ! Browse has a locator for sort order 1
  BRW1::Sort1:Locator.Init(,DEP:MNGR_NO,,BRW1)             ! Initialize the browse locator using  using key: DEP:INTEG_31 , DEP:MNGR_NO
  BRW1.AddSortOrder(,DEP:INTEG_17)                         ! Add the sort order for DEP:INTEG_17 for sort order 2
  BRW1.AddLocator(BRW1::Sort2:Locator)                     ! Browse has a locator for sort order 2
  BRW1::Sort2:Locator.Init(,DEP:HEAD_DEPT,,BRW1)           ! Initialize the browse locator using  using key: DEP:INTEG_17 , DEP:HEAD_DEPT
  BRW1.AddSortOrder(,DEP:INTEG_16)                         ! Add the sort order for DEP:INTEG_16 for sort order 3
  BRW1.AddLocator(BRW1::Sort3:Locator)                     ! Browse has a locator for sort order 3
  BRW1::Sort3:Locator.Init(,DEP:DEPT_NO,,BRW1)             ! Initialize the browse locator using  using key: DEP:INTEG_16 , DEP:DEPT_NO
  BRW1.AddSortOrder(,DEP:RDB_4)                            ! Add the sort order for DEP:RDB_4 for sort order 4
  BRW1.AddLocator(BRW1::Sort4:Locator)                     ! Browse has a locator for sort order 4
  BRW1::Sort4:Locator.Init(,DEP:DEPARTMENT,,BRW1)          ! Initialize the browse locator using  using key: DEP:RDB_4 , DEP:DEPARTMENT
  BRW1.AddSortOrder(,DEP:BUDGETX)                          ! Add the sort order for DEP:BUDGETX for sort order 5
  BRW1.AddLocator(BRW1::Sort0:Locator)                     ! Browse has a locator for sort order 5
  BRW1::Sort0:Locator.Init(,DEP:BUDGET,,BRW1)              ! Initialize the browse locator using  using key: DEP:BUDGETX , DEP:BUDGET
  BRW1.AddField(DEP:DEPT_NO,BRW1.Q.DEP:DEPT_NO)            ! Field DEP:DEPT_NO is a hot field or requires assignment from browse
  BRW1.AddField(DEP:DEPARTMENT,BRW1.Q.DEP:DEPARTMENT)      ! Field DEP:DEPARTMENT is a hot field or requires assignment from browse
  BRW1.AddField(DEP:HEAD_DEPT,BRW1.Q.DEP:HEAD_DEPT)        ! Field DEP:HEAD_DEPT is a hot field or requires assignment from browse
  BRW1.AddField(DEP:MNGR_NO,BRW1.Q.DEP:MNGR_NO)            ! Field DEP:MNGR_NO is a hot field or requires assignment from browse
  BRW1.AddField(DEP:BUDGET,BRW1.Q.DEP:BUDGET)              ! Field DEP:BUDGET is a hot field or requires assignment from browse
  BRW1.AddField(DEP:LOCATION,BRW1.Q.DEP:LOCATION)          ! Field DEP:LOCATION is a hot field or requires assignment from browse
  BRW1.AddField(DEP:PHONE_NO,BRW1.Q.DEP:PHONE_NO)          ! Field DEP:PHONE_NO is a hot field or requires assignment from browse
  Resizer.Init(AppStrategy:Surface,Resize:SetMinSize)      ! Controls like list boxes will resize, whilst controls like buttons will move
  SELF.AddItem(Resizer)                                    ! Add resizer to window manager
  INIMgr.Fetch('SelectDEPARTMENT',QuickWindow)             ! Restore window settings from non-volatile store
  Resizer.Resize                                           ! Reset required after window size altered by INI manager
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:DEPARTMENT.Close
  END
  IF SELF.Opened
    INIMgr.Update('SelectDEPARTMENT',QuickWindow)          ! Save window data to non-volatile store
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


BRW1.Init PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)

  CODE
  SELF.SelectControl = ?Select:2
  SELF.HideSelect = 1                                      ! Hide the select button when disabled
  PARENT.Init(ListBox,Posit,V,Q,RM,WM)


BRW1.ResetSort PROCEDURE(BYTE Force)

ReturnValue          BYTE,AUTO

  CODE
  IF CHOICE(?CurrentTab) = 2
    RETURN SELF.SetSort(1,Force)
  ELSIF CHOICE(?CurrentTab) = 3
    RETURN SELF.SetSort(2,Force)
  ELSIF CHOICE(?CurrentTab) = 4
    RETURN SELF.SetSort(3,Force)
  ELSIF CHOICE(?CurrentTab) = 5
    RETURN SELF.SetSort(4,Force)
  ELSE
    RETURN SELF.SetSort(5,Force)
  END
  ReturnValue = PARENT.ResetSort(Force)
  RETURN ReturnValue


Resizer.Init PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)


  CODE
  PARENT.Init(AppStrategy,SetWindowMinSize,SetWindowMaxSize)
  SELF.SetParentDefaults()                                 ! Calculate default control parent-child relationships based upon their positions on the window

!!! <summary>
!!! Generated from procedure template - Window
!!! Select a JOB Record
!!! </summary>
SelectJOB PROCEDURE 

CurrentTab           STRING(80)                            !
BRW1::View:Browse    VIEW(JOB)
                       PROJECT(JOB:JOB_CODE)
                       PROJECT(JOB:JOB_GRADE)
                       PROJECT(JOB:JOB_COUNTRY)
                       PROJECT(JOB:JOB_TITLE)
                       PROJECT(JOB:MIN_SALARY)
                       PROJECT(JOB:MAX_SALARY)
                       PROJECT(JOB:LANGUAGE_REQ)
                     END
Queue:Browse:1       QUEUE                            !Queue declaration for browse/combo box using ?Browse:1
JOB:JOB_CODE           LIKE(JOB:JOB_CODE)             !List box control field - type derived from field
JOB:JOB_GRADE          LIKE(JOB:JOB_GRADE)            !List box control field - type derived from field
JOB:JOB_COUNTRY        LIKE(JOB:JOB_COUNTRY)          !List box control field - type derived from field
JOB:JOB_TITLE          LIKE(JOB:JOB_TITLE)            !List box control field - type derived from field
JOB:MIN_SALARY         LIKE(JOB:MIN_SALARY)           !List box control field - type derived from field
JOB:MAX_SALARY         LIKE(JOB:MAX_SALARY)           !List box control field - type derived from field
JOB:LANGUAGE_REQ       LIKE(JOB:LANGUAGE_REQ)         !List box control field - type derived from field
Mark                   BYTE                           !Entry's marked status
ViewPosition           STRING(1024)                   !Entry's view position
                     END
QuickWindow          WINDOW('Select a JOB Record'),AT(,,358,198),FONT('MS Sans Serif',8,,FONT:regular,CHARSET:DEFAULT), |
  RESIZE,CENTER,GRAY,IMM,MDI,HLP('SelectJOB'),SYSTEM
                       LIST,AT(8,30,342,124),USE(?Browse:1),HVSCROLL,FORMAT('36L(2)|M~JOB CODE~L(2)@s5@40R(2)|' & |
  'M~JOB GRADE~C(0)@n-7@64L(2)|M~JOB COUNTRY~L(2)@s15@80L(2)|M~JOB TITLE~L(2)@s25@64D(1' & |
  '8)|M~MIN SALARY~C(0)@n-14.2@64D(18)|M~MAX SALARY~C(0)@n-14.2@80L(2)|M~LANGUAGE REQ~L(2)@s91@'), |
  FROM(Queue:Browse:1),IMM,MSG('Browsing the JOB file')
                       BUTTON('&Select'),AT(301,158,49,14),USE(?Select:2),LEFT,ICON('WASELECT.ICO'),FLAT,MSG('Select the Record'), |
  TIP('Select the Record')
                       SHEET,AT(4,4,350,172),USE(?CurrentTab)
                         TAB('&1) MAXSALX'),USE(?Tab:2)
                         END
                         TAB('&2) MINSALX'),USE(?Tab:3)
                         END
                         TAB('&3) INTEG_11'),USE(?Tab:4)
                         END
                         TAB('&4) INTEG_10'),USE(?Tab:5)
                         END
                       END
                       BUTTON('&Close'),AT(252,180,49,14),USE(?Close),LEFT,ICON('WACLOSE.ICO'),FLAT,MSG('Close Window'), |
  TIP('Close Window')
                       BUTTON('&Help'),AT(305,180,49,14),USE(?Help),LEFT,ICON('WAHELP.ICO'),FLAT,MSG('See Help Window'), |
  STD(STD:Help),TIP('See Help Window')
                     END

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass
BRW1                 CLASS(BrowseClass)                    ! Browse using ?Browse:1
Q                      &Queue:Browse:1                !Reference to browse queue
Init                   PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)
ResetSort              PROCEDURE(BYTE Force),BYTE,PROC,DERIVED
                     END

BRW1::Sort0:Locator  StepLocatorClass                      ! Default Locator
BRW1::Sort1:Locator  StepLocatorClass                      ! Conditional Locator - CHOICE(?CurrentTab) = 2
BRW1::Sort2:Locator  StepLocatorClass                      ! Conditional Locator - CHOICE(?CurrentTab) = 3
BRW1::Sort3:Locator  StepLocatorClass                      ! Conditional Locator - CHOICE(?CurrentTab) = 4
Resizer              CLASS(WindowResizeClass)
Init                   PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)
                     END


  CODE
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------

ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('SelectJOB')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?Browse:1
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  BIND('JOB:JOB_CODE',JOB:JOB_CODE)                        ! Added by: BrowseBox(ABC)
  BIND('JOB:JOB_GRADE',JOB:JOB_GRADE)                      ! Added by: BrowseBox(ABC)
  BIND('JOB:JOB_COUNTRY',JOB:JOB_COUNTRY)                  ! Added by: BrowseBox(ABC)
  BIND('JOB:JOB_TITLE',JOB:JOB_TITLE)                      ! Added by: BrowseBox(ABC)
  BIND('JOB:MIN_SALARY',JOB:MIN_SALARY)                    ! Added by: BrowseBox(ABC)
  BIND('JOB:MAX_SALARY',JOB:MAX_SALARY)                    ! Added by: BrowseBox(ABC)
  BIND('JOB:LANGUAGE_REQ',JOB:LANGUAGE_REQ)                ! Added by: BrowseBox(ABC)
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  IF SELF.Request = SelectRecord
     SELF.AddItem(?Close,RequestCancelled)                 ! Add the close control to the window manger
  ELSE
     SELF.AddItem(?Close,RequestCompleted)                 ! Add the close control to the window manger
  END
  Relate:JOB.Open                                          ! File JOB used by this procedure, so make sure it's RelationManager is open
  SELF.FilesOpened = True
  BRW1.Init(?Browse:1,Queue:Browse:1.ViewPosition,BRW1::View:Browse,Queue:Browse:1,Relate:JOB,SELF) ! Initialize the browse manager
  SELF.Open(QuickWindow)                                   ! Open window
  Do DefineListboxStyle
  BRW1.Q &= Queue:Browse:1
  BRW1.RetainRow = 0
  BRW1.AddSortOrder(,JOB:MINSALX)                          ! Add the sort order for JOB:MINSALX for sort order 1
  BRW1.AddLocator(BRW1::Sort1:Locator)                     ! Browse has a locator for sort order 1
  BRW1::Sort1:Locator.Init(,JOB:JOB_COUNTRY,,BRW1)         ! Initialize the browse locator using  using key: JOB:MINSALX , JOB:JOB_COUNTRY
  BRW1.AddSortOrder(,JOB:INTEG_11)                         ! Add the sort order for JOB:INTEG_11 for sort order 2
  BRW1.AddLocator(BRW1::Sort2:Locator)                     ! Browse has a locator for sort order 2
  BRW1::Sort2:Locator.Init(,JOB:JOB_COUNTRY,,BRW1)         ! Initialize the browse locator using  using key: JOB:INTEG_11 , JOB:JOB_COUNTRY
  BRW1.AddSortOrder(,JOB:INTEG_10)                         ! Add the sort order for JOB:INTEG_10 for sort order 3
  BRW1.AddLocator(BRW1::Sort3:Locator)                     ! Browse has a locator for sort order 3
  BRW1::Sort3:Locator.Init(,JOB:JOB_CODE,,BRW1)            ! Initialize the browse locator using  using key: JOB:INTEG_10 , JOB:JOB_CODE
  BRW1.AddSortOrder(,JOB:MAXSALX)                          ! Add the sort order for JOB:MAXSALX for sort order 4
  BRW1.AddLocator(BRW1::Sort0:Locator)                     ! Browse has a locator for sort order 4
  BRW1::Sort0:Locator.Init(,JOB:JOB_COUNTRY,,BRW1)         ! Initialize the browse locator using  using key: JOB:MAXSALX , JOB:JOB_COUNTRY
  BRW1.AddField(JOB:JOB_CODE,BRW1.Q.JOB:JOB_CODE)          ! Field JOB:JOB_CODE is a hot field or requires assignment from browse
  BRW1.AddField(JOB:JOB_GRADE,BRW1.Q.JOB:JOB_GRADE)        ! Field JOB:JOB_GRADE is a hot field or requires assignment from browse
  BRW1.AddField(JOB:JOB_COUNTRY,BRW1.Q.JOB:JOB_COUNTRY)    ! Field JOB:JOB_COUNTRY is a hot field or requires assignment from browse
  BRW1.AddField(JOB:JOB_TITLE,BRW1.Q.JOB:JOB_TITLE)        ! Field JOB:JOB_TITLE is a hot field or requires assignment from browse
  BRW1.AddField(JOB:MIN_SALARY,BRW1.Q.JOB:MIN_SALARY)      ! Field JOB:MIN_SALARY is a hot field or requires assignment from browse
  BRW1.AddField(JOB:MAX_SALARY,BRW1.Q.JOB:MAX_SALARY)      ! Field JOB:MAX_SALARY is a hot field or requires assignment from browse
  BRW1.AddField(JOB:LANGUAGE_REQ,BRW1.Q.JOB:LANGUAGE_REQ)  ! Field JOB:LANGUAGE_REQ is a hot field or requires assignment from browse
  Resizer.Init(AppStrategy:Surface,Resize:SetMinSize)      ! Controls like list boxes will resize, whilst controls like buttons will move
  SELF.AddItem(Resizer)                                    ! Add resizer to window manager
  INIMgr.Fetch('SelectJOB',QuickWindow)                    ! Restore window settings from non-volatile store
  Resizer.Resize                                           ! Reset required after window size altered by INI manager
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:JOB.Close
  END
  IF SELF.Opened
    INIMgr.Update('SelectJOB',QuickWindow)                 ! Save window data to non-volatile store
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


BRW1.Init PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)

  CODE
  SELF.SelectControl = ?Select:2
  SELF.HideSelect = 1                                      ! Hide the select button when disabled
  PARENT.Init(ListBox,Posit,V,Q,RM,WM)


BRW1.ResetSort PROCEDURE(BYTE Force)

ReturnValue          BYTE,AUTO

  CODE
  IF CHOICE(?CurrentTab) = 2
    RETURN SELF.SetSort(1,Force)
  ELSIF CHOICE(?CurrentTab) = 3
    RETURN SELF.SetSort(2,Force)
  ELSIF CHOICE(?CurrentTab) = 4
    RETURN SELF.SetSort(3,Force)
  ELSE
    RETURN SELF.SetSort(4,Force)
  END
  ReturnValue = PARENT.ResetSort(Force)
  RETURN ReturnValue


Resizer.Init PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)


  CODE
  PARENT.Init(AppStrategy,SetWindowMinSize,SetWindowMaxSize)
  SELF.SetParentDefaults()                                 ! Calculate default control parent-child relationships based upon their positions on the window

!!! <summary>
!!! Generated from procedure template - Window
!!! Form EMPLOYEE
!!! </summary>
UpdateEMPLOYEE PROCEDURE 

CurrentTab           STRING(80)                            !
ActionMessage        CSTRING(40)                           !
History::EMP:Record  LIKE(EMP:RECORD),THREAD
QuickWindow          WINDOW('Form EMPLOYEE'),AT(,,232,182),FONT('MS Sans Serif',8,,FONT:regular,CHARSET:DEFAULT), |
  RESIZE,CENTER,GRAY,IMM,MDI,HLP('UpdateEMPLOYEE'),SYSTEM
                       SHEET,AT(4,4,224,156),USE(?CurrentTab)
                         TAB('&1) General'),USE(?Tab:1)
                           PROMPT('EMP NO:'),AT(8,20),USE(?EMP:EMP_NO:Prompt),TRN
                           ENTRY(@n-7),AT(72,20,40,10),USE(EMP:EMP_NO)
                           PROMPT('FIRST NAME:'),AT(8,34),USE(?EMP:FIRST_NAME:Prompt),TRN
                           ENTRY(@s15),AT(72,34,64,10),USE(EMP:FIRST_NAME)
                           PROMPT('LAST NAME:'),AT(8,48),USE(?EMP:LAST_NAME:Prompt),TRN
                           ENTRY(@s20),AT(72,48,84,10),USE(EMP:LAST_NAME)
                           PROMPT('PHONE EXT:'),AT(8,62),USE(?EMP:PHONE_EXT:Prompt),TRN
                           ENTRY(@s4),AT(72,62,40,10),USE(EMP:PHONE_EXT)
                           PROMPT('HIRE DATE DATE:'),AT(8,76),USE(?EMP:HIRE_DATE_DATE:Prompt),TRN
                           ENTRY(@d17),AT(72,76,104,10),USE(EMP:HIRE_DATE_DATE)
                           PROMPT('HIRE DATE TIME:'),AT(8,90),USE(?EMP:HIRE_DATE_TIME:Prompt),TRN
                           ENTRY(@t7),AT(72,90,104,10),USE(EMP:HIRE_DATE_TIME)
                           PROMPT('DEPT NO:'),AT(8,104),USE(?EMP:DEPT_NO:Prompt),TRN
                           ENTRY(@s3),AT(72,104,40,10),USE(EMP:DEPT_NO)
                           PROMPT('JOB CODE:'),AT(8,118),USE(?EMP:JOB_CODE:Prompt),TRN
                           ENTRY(@s5),AT(72,118,40,10),USE(EMP:JOB_CODE)
                           PROMPT('JOB GRADE:'),AT(8,132),USE(?EMP:JOB_GRADE:Prompt),TRN
                           ENTRY(@n-7),AT(72,132,40,10),USE(EMP:JOB_GRADE)
                           PROMPT('JOB COUNTRY:'),AT(8,146),USE(?EMP:JOB_COUNTRY:Prompt),TRN
                           ENTRY(@s15),AT(72,146,64,10),USE(EMP:JOB_COUNTRY)
                         END
                         TAB('&2) General (cont.)'),USE(?Tab:2)
                           PROMPT('SALARY:'),AT(8,20),USE(?EMP:SALARY:Prompt),TRN
                           ENTRY(@n-14.2),AT(72,20,64,10),USE(EMP:SALARY)
                           PROMPT('FULL NAME:'),AT(8,34),USE(?EMP:FULL_NAME:Prompt),TRN
                           ENTRY(@s37),AT(72,34,152,10),USE(EMP:FULL_NAME)
                         END
                       END
                       BUTTON('&OK'),AT(73,164,49,14),USE(?OK),LEFT,ICON('WAOK.ICO'),DEFAULT,FLAT,MSG('Accept dat' & |
  'a and close the window'),TIP('Accept data and close the window')
                       BUTTON('&Cancel'),AT(126,164,49,14),USE(?Cancel),LEFT,ICON('WACANCEL.ICO'),FLAT,MSG('Cancel operation'), |
  TIP('Cancel operation')
                       BUTTON('&Help'),AT(179,164,49,14),USE(?Help),LEFT,ICON('WAHELP.ICO'),FLAT,MSG('See Help Window'), |
  STD(STD:Help),TIP('See Help Window')
                     END

ThisWindow           CLASS(WindowManager)
Ask                    PROCEDURE(),DERIVED
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
Run                    PROCEDURE(),BYTE,PROC,DERIVED
Run                    PROCEDURE(USHORT Number,BYTE Request),BYTE,PROC,DERIVED
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass
Resizer              CLASS(WindowResizeClass)
Init                   PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)
                     END

CurCtrlFeq          LONG
FieldColorQueue     QUEUE
Feq                   LONG
OldColor              LONG
                    END

  CODE
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------

ThisWindow.Ask PROCEDURE

  CODE
  CASE SELF.Request                                        ! Configure the action message text
  OF ViewRecord
    ActionMessage = 'View Record'
  OF InsertRecord
    ActionMessage = 'Record Will Be Added'
  OF ChangeRecord
    ActionMessage = 'Record Will Be Changed'
  END
  QuickWindow{PROP:Text} = ActionMessage                   ! Display status message in title bar
  PARENT.Ask


ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('UpdateEMPLOYEE')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?EMP:EMP_NO:Prompt
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  SELF.HistoryKey = CtrlH
  SELF.AddHistoryFile(EMP:Record,History::EMP:Record)
  SELF.AddHistoryField(?EMP:EMP_NO,1)
  SELF.AddHistoryField(?EMP:FIRST_NAME,2)
  SELF.AddHistoryField(?EMP:LAST_NAME,3)
  SELF.AddHistoryField(?EMP:PHONE_EXT,4)
  SELF.AddHistoryField(?EMP:HIRE_DATE_DATE,7)
  SELF.AddHistoryField(?EMP:HIRE_DATE_TIME,8)
  SELF.AddHistoryField(?EMP:DEPT_NO,9)
  SELF.AddHistoryField(?EMP:JOB_CODE,10)
  SELF.AddHistoryField(?EMP:JOB_GRADE,11)
  SELF.AddHistoryField(?EMP:JOB_COUNTRY,12)
  SELF.AddHistoryField(?EMP:SALARY,13)
  SELF.AddHistoryField(?EMP:FULL_NAME,14)
  SELF.AddUpdateFile(Access:EMPLOYEE)
  SELF.AddItem(?Cancel,RequestCancelled)                   ! Add the cancel control to the window manager
  Relate:DEPARTMENT.Open                                   ! File DEPARTMENT used by this procedure, so make sure it's RelationManager is open
  Relate:EMPLOYEE.Open                                     ! File EMPLOYEE used by this procedure, so make sure it's RelationManager is open
  Relate:JOB.Open                                          ! File JOB used by this procedure, so make sure it's RelationManager is open
  SELF.FilesOpened = True
  SELF.Primary &= Relate:EMPLOYEE
  IF SELF.Request = ViewRecord AND NOT SELF.BatchProcessing ! Setup actions for ViewOnly Mode
    SELF.InsertAction = Insert:None
    SELF.DeleteAction = Delete:None
    SELF.ChangeAction = Change:None
    SELF.CancelAction = Cancel:Cancel
    SELF.OkControl = 0
  ELSE
    SELF.ChangeAction = Change:Caller                      ! Changes allowed
    SELF.CancelAction = Cancel:Cancel+Cancel:Query         ! Confirm cancel
    SELF.OkControl = ?OK
    IF SELF.PrimeUpdate() THEN RETURN Level:Notify.
  END
  SELF.Open(QuickWindow)                                   ! Open window
  Do DefineListboxStyle
  IF SELF.Request = ViewRecord                             ! Configure controls for View Only mode
    ?EMP:EMP_NO{PROP:ReadOnly} = True
    ?EMP:FIRST_NAME{PROP:ReadOnly} = True
    ?EMP:LAST_NAME{PROP:ReadOnly} = True
    ?EMP:PHONE_EXT{PROP:ReadOnly} = True
    ?EMP:HIRE_DATE_DATE{PROP:ReadOnly} = True
    ?EMP:HIRE_DATE_TIME{PROP:ReadOnly} = True
    ?EMP:DEPT_NO{PROP:ReadOnly} = True
    ?EMP:JOB_CODE{PROP:ReadOnly} = True
    ?EMP:JOB_GRADE{PROP:ReadOnly} = True
    ?EMP:JOB_COUNTRY{PROP:ReadOnly} = True
    ?EMP:SALARY{PROP:ReadOnly} = True
    ?EMP:FULL_NAME{PROP:ReadOnly} = True
  END
  Resizer.Init(AppStrategy:Surface,Resize:SetMinSize)      ! Controls like list boxes will resize, whilst controls like buttons will move
  SELF.AddItem(Resizer)                                    ! Add resizer to window manager
  INIMgr.Fetch('UpdateEMPLOYEE',QuickWindow)               ! Restore window settings from non-volatile store
  Resizer.Resize                                           ! Reset required after window size altered by INI manager
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:DEPARTMENT.Close
    Relate:EMPLOYEE.Close
    Relate:JOB.Close
  END
  IF SELF.Opened
    INIMgr.Update('UpdateEMPLOYEE',QuickWindow)            ! Save window data to non-volatile store
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.Run PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run()
  IF SELF.Request = ViewRecord                             ! In View Only mode always signal RequestCancelled
    ReturnValue = RequestCancelled
  END
  RETURN ReturnValue


ThisWindow.Run PROCEDURE(USHORT Number,BYTE Request)

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run(Number,Request)
  IF SELF.Request = ViewRecord
    ReturnValue = RequestCancelled                         ! Always return RequestCancelled if the form was opened in ViewRecord mode
  ELSE
    GlobalRequest = Request
    EXECUTE Number
      SelectDEPARTMENT
      SelectJOB
      SelectJOB
      SelectJOB
    END
    ReturnValue = GlobalResponse
  END
  RETURN ReturnValue


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receive all EVENT:Accepted's
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
  ReturnValue = PARENT.TakeAccepted()
    CASE ACCEPTED()
    OF ?EMP:DEPT_NO
      DEP:DEPT_NO = EMP:DEPT_NO
      IF Access:DEPARTMENT.TryFetch(DEP:INTEG_16)
        IF SELF.Run(1,SelectRecord) = RequestCompleted
          EMP:DEPT_NO = DEP:DEPT_NO
        ELSE
          SELECT(?EMP:DEPT_NO)
          CYCLE
        END
      END
      ThisWindow.Reset(0)
      IF Access:EMPLOYEE.TryValidateField(9)               ! Attempt to validate EMP:DEPT_NO in EMPLOYEE
        SELECT(?EMP:DEPT_NO)
        QuickWindow{PROP:AcceptAll} = False
        CYCLE
      ELSE
        FieldColorQueue.Feq = ?EMP:DEPT_NO
        GET(FieldColorQueue, FieldColorQueue.Feq)
        IF ERRORCODE() = 0
          ?EMP:DEPT_NO{PROP:FontColor} = FieldColorQueue.OldColor
          DELETE(FieldColorQueue)
        END
      END
    OF ?EMP:JOB_CODE
      JOB:JOB_CODE = EMP:JOB_CODE
      JOB:JOB_GRADE = EMP:JOB_GRADE
      JOB:JOB_COUNTRY = EMP:JOB_CODE
      IF Access:JOB.TryFetch(JOB:INTEG_10)
        IF SELF.Run(2,SelectRecord) = RequestCompleted
          EMP:JOB_CODE = JOB:JOB_CODE
          EMP:JOB_GRADE = JOB:JOB_GRADE
          EMP:JOB_CODE = JOB:JOB_COUNTRY
        ELSE
          SELECT(?EMP:JOB_CODE)
          CYCLE
        END
      END
      ThisWindow.Reset(0)
      IF Access:EMPLOYEE.TryValidateField(10)              ! Attempt to validate EMP:JOB_CODE in EMPLOYEE
        SELECT(?EMP:JOB_CODE)
        QuickWindow{PROP:AcceptAll} = False
        CYCLE
      ELSE
        FieldColorQueue.Feq = ?EMP:JOB_CODE
        GET(FieldColorQueue, FieldColorQueue.Feq)
        IF ERRORCODE() = 0
          ?EMP:JOB_CODE{PROP:FontColor} = FieldColorQueue.OldColor
          DELETE(FieldColorQueue)
        END
      END
    OF ?EMP:JOB_GRADE
      JOB:JOB_CODE = EMP:JOB_CODE
      JOB:JOB_GRADE = EMP:JOB_GRADE
      JOB:JOB_COUNTRY = EMP:JOB_GRADE
      IF Access:JOB.TryFetch(JOB:INTEG_10)
        IF SELF.Run(2,SelectRecord) = RequestCompleted
          EMP:JOB_CODE = JOB:JOB_CODE
          EMP:JOB_GRADE = JOB:JOB_GRADE
          EMP:JOB_GRADE = JOB:JOB_COUNTRY
        ELSE
          SELECT(?EMP:JOB_GRADE)
          CYCLE
        END
      END
      ThisWindow.Reset(0)
      IF Access:EMPLOYEE.TryValidateField(11)              ! Attempt to validate EMP:JOB_GRADE in EMPLOYEE
        SELECT(?EMP:JOB_GRADE)
        QuickWindow{PROP:AcceptAll} = False
        CYCLE
      ELSE
        FieldColorQueue.Feq = ?EMP:JOB_GRADE
        GET(FieldColorQueue, FieldColorQueue.Feq)
        IF ERRORCODE() = 0
          ?EMP:JOB_GRADE{PROP:FontColor} = FieldColorQueue.OldColor
          DELETE(FieldColorQueue)
        END
      END
    OF ?EMP:JOB_COUNTRY
      JOB:JOB_CODE = EMP:JOB_CODE
      JOB:JOB_GRADE = EMP:JOB_GRADE
      JOB:JOB_COUNTRY = EMP:JOB_COUNTRY
      IF Access:JOB.TryFetch(JOB:INTEG_10)
        IF SELF.Run(2,SelectRecord) = RequestCompleted
          EMP:JOB_CODE = JOB:JOB_CODE
          EMP:JOB_GRADE = JOB:JOB_GRADE
          EMP:JOB_COUNTRY = JOB:JOB_COUNTRY
        ELSE
          SELECT(?EMP:JOB_COUNTRY)
          CYCLE
        END
      END
      ThisWindow.Reset(0)
      IF Access:EMPLOYEE.TryValidateField(12)              ! Attempt to validate EMP:JOB_COUNTRY in EMPLOYEE
        SELECT(?EMP:JOB_COUNTRY)
        QuickWindow{PROP:AcceptAll} = False
        CYCLE
      ELSE
        FieldColorQueue.Feq = ?EMP:JOB_COUNTRY
        GET(FieldColorQueue, FieldColorQueue.Feq)
        IF ERRORCODE() = 0
          ?EMP:JOB_COUNTRY{PROP:FontColor} = FieldColorQueue.OldColor
          DELETE(FieldColorQueue)
        END
      END
    OF ?OK
      ThisWindow.Update
      IF SELF.Request = ViewRecord AND NOT SELF.BatchProcessing THEN
         POST(EVENT:CloseWindow)
      END
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


Resizer.Init PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)


  CODE
  PARENT.Init(AppStrategy,SetWindowMinSize,SetWindowMaxSize)
  SELF.SetParentDefaults()                                 ! Calculate default control parent-child relationships based upon their positions on the window

!!! <summary>
!!! Generated from procedure template - Window
!!! Select a PROJECT Record
!!! </summary>
SelectPROJECT PROCEDURE 

CurrentTab           STRING(80)                            !
BRW1::View:Browse    VIEW(PROJECT)
                       PROJECT(PRO:PROJ_ID)
                       PROJECT(PRO:PROJ_NAME)
                       PROJECT(PRO:TEAM_LEADER)
                       PROJECT(PRO:PRODUCT)
                     END
Queue:Browse:1       QUEUE                            !Queue declaration for browse/combo box using ?Browse:1
PRO:PROJ_ID            LIKE(PRO:PROJ_ID)              !List box control field - type derived from field
PRO:PROJ_NAME          LIKE(PRO:PROJ_NAME)            !List box control field - type derived from field
PRO:TEAM_LEADER        LIKE(PRO:TEAM_LEADER)          !List box control field - type derived from field
PRO:PRODUCT            LIKE(PRO:PRODUCT)              !List box control field - type derived from field
Mark                   BYTE                           !Entry's marked status
ViewPosition           STRING(1024)                   !Entry's view position
                     END
QuickWindow          WINDOW('Select a PROJECT Record'),AT(,,220,198),FONT('MS Sans Serif',8,,FONT:regular,CHARSET:DEFAULT), |
  RESIZE,CENTER,GRAY,IMM,MDI,HLP('SelectPROJECT'),SYSTEM
                       LIST,AT(8,30,204,124),USE(?Browse:1),HVSCROLL,FORMAT('32L(2)|M~PROJ ID~L(2)@s5@80L(2)|M' & |
  '~PROJ NAME~L(2)@s20@48R(2)|M~TEAM LEADER~C(0)@n-7@52L(2)|M~PRODUCT~L(2)@s12@'),FROM(Queue:Browse:1), |
  IMM,MSG('Browsing the PROJECT file')
                       BUTTON('&Select'),AT(163,158,49,14),USE(?Select:2),LEFT,ICON('WASELECT.ICO'),FLAT,MSG('Select the Record'), |
  TIP('Select the Record')
                       SHEET,AT(4,4,212,172),USE(?CurrentTab)
                         TAB('&1) INTEG_36'),USE(?Tab:2)
                         END
                         TAB('&2) PRODTYPEX'),USE(?Tab:3)
                         END
                         TAB('&3) INTEG_35'),USE(?Tab:4)
                         END
                         TAB('&4) RDB_11'),USE(?Tab:5)
                         END
                       END
                       BUTTON('&Close'),AT(114,180,49,14),USE(?Close),LEFT,ICON('WACLOSE.ICO'),FLAT,MSG('Close Window'), |
  TIP('Close Window')
                       BUTTON('&Help'),AT(167,180,49,14),USE(?Help),LEFT,ICON('WAHELP.ICO'),FLAT,MSG('See Help Window'), |
  STD(STD:Help),TIP('See Help Window')
                     END

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass
BRW1                 CLASS(BrowseClass)                    ! Browse using ?Browse:1
Q                      &Queue:Browse:1                !Reference to browse queue
Init                   PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)
ResetSort              PROCEDURE(BYTE Force),BYTE,PROC,DERIVED
                     END

BRW1::Sort0:Locator  StepLocatorClass                      ! Default Locator
BRW1::Sort1:Locator  StepLocatorClass                      ! Conditional Locator - CHOICE(?CurrentTab) = 2
BRW1::Sort2:Locator  StepLocatorClass                      ! Conditional Locator - CHOICE(?CurrentTab) = 3
BRW1::Sort3:Locator  StepLocatorClass                      ! Conditional Locator - CHOICE(?CurrentTab) = 4
Resizer              CLASS(WindowResizeClass)
Init                   PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)
                     END


  CODE
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------

ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('SelectPROJECT')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?Browse:1
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  BIND('PRO:PROJ_ID',PRO:PROJ_ID)                          ! Added by: BrowseBox(ABC)
  BIND('PRO:PROJ_NAME',PRO:PROJ_NAME)                      ! Added by: BrowseBox(ABC)
  BIND('PRO:TEAM_LEADER',PRO:TEAM_LEADER)                  ! Added by: BrowseBox(ABC)
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  IF SELF.Request = SelectRecord
     SELF.AddItem(?Close,RequestCancelled)                 ! Add the close control to the window manger
  ELSE
     SELF.AddItem(?Close,RequestCompleted)                 ! Add the close control to the window manger
  END
  Relate:PROJECT.Open                                      ! File PROJECT used by this procedure, so make sure it's RelationManager is open
  SELF.FilesOpened = True
  BRW1.Init(?Browse:1,Queue:Browse:1.ViewPosition,BRW1::View:Browse,Queue:Browse:1,Relate:PROJECT,SELF) ! Initialize the browse manager
  SELF.Open(QuickWindow)                                   ! Open window
  Do DefineListboxStyle
  BRW1.Q &= Queue:Browse:1
  BRW1.RetainRow = 0
  BRW1.AddSortOrder(,PRO:PRODTYPEX)                        ! Add the sort order for PRO:PRODTYPEX for sort order 1
  BRW1.AddLocator(BRW1::Sort1:Locator)                     ! Browse has a locator for sort order 1
  BRW1::Sort1:Locator.Init(,PRO:PRODUCT,,BRW1)             ! Initialize the browse locator using  using key: PRO:PRODTYPEX , PRO:PRODUCT
  BRW1.AddSortOrder(,PRO:INTEG_35)                         ! Add the sort order for PRO:INTEG_35 for sort order 2
  BRW1.AddLocator(BRW1::Sort2:Locator)                     ! Browse has a locator for sort order 2
  BRW1::Sort2:Locator.Init(,PRO:PROJ_ID,,BRW1)             ! Initialize the browse locator using  using key: PRO:INTEG_35 , PRO:PROJ_ID
  BRW1.AddSortOrder(,PRO:RDB_11)                           ! Add the sort order for PRO:RDB_11 for sort order 3
  BRW1.AddLocator(BRW1::Sort3:Locator)                     ! Browse has a locator for sort order 3
  BRW1::Sort3:Locator.Init(,PRO:PROJ_NAME,,BRW1)           ! Initialize the browse locator using  using key: PRO:RDB_11 , PRO:PROJ_NAME
  BRW1.AddSortOrder(,PRO:INTEG_36)                         ! Add the sort order for PRO:INTEG_36 for sort order 4
  BRW1.AddLocator(BRW1::Sort0:Locator)                     ! Browse has a locator for sort order 4
  BRW1::Sort0:Locator.Init(,PRO:TEAM_LEADER,,BRW1)         ! Initialize the browse locator using  using key: PRO:INTEG_36 , PRO:TEAM_LEADER
  BRW1.AddField(PRO:PROJ_ID,BRW1.Q.PRO:PROJ_ID)            ! Field PRO:PROJ_ID is a hot field or requires assignment from browse
  BRW1.AddField(PRO:PROJ_NAME,BRW1.Q.PRO:PROJ_NAME)        ! Field PRO:PROJ_NAME is a hot field or requires assignment from browse
  BRW1.AddField(PRO:TEAM_LEADER,BRW1.Q.PRO:TEAM_LEADER)    ! Field PRO:TEAM_LEADER is a hot field or requires assignment from browse
  BRW1.AddField(PRO:PRODUCT,BRW1.Q.PRO:PRODUCT)            ! Field PRO:PRODUCT is a hot field or requires assignment from browse
  Resizer.Init(AppStrategy:Surface,Resize:SetMinSize)      ! Controls like list boxes will resize, whilst controls like buttons will move
  SELF.AddItem(Resizer)                                    ! Add resizer to window manager
  INIMgr.Fetch('SelectPROJECT',QuickWindow)                ! Restore window settings from non-volatile store
  Resizer.Resize                                           ! Reset required after window size altered by INI manager
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:PROJECT.Close
  END
  IF SELF.Opened
    INIMgr.Update('SelectPROJECT',QuickWindow)             ! Save window data to non-volatile store
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


BRW1.Init PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)

  CODE
  SELF.SelectControl = ?Select:2
  SELF.HideSelect = 1                                      ! Hide the select button when disabled
  PARENT.Init(ListBox,Posit,V,Q,RM,WM)


BRW1.ResetSort PROCEDURE(BYTE Force)

ReturnValue          BYTE,AUTO

  CODE
  IF CHOICE(?CurrentTab) = 2
    RETURN SELF.SetSort(1,Force)
  ELSIF CHOICE(?CurrentTab) = 3
    RETURN SELF.SetSort(2,Force)
  ELSIF CHOICE(?CurrentTab) = 4
    RETURN SELF.SetSort(3,Force)
  ELSE
    RETURN SELF.SetSort(4,Force)
  END
  ReturnValue = PARENT.ResetSort(Force)
  RETURN ReturnValue


Resizer.Init PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)


  CODE
  PARENT.Init(AppStrategy,SetWindowMinSize,SetWindowMaxSize)
  SELF.SetParentDefaults()                                 ! Calculate default control parent-child relationships based upon their positions on the window

!!! <summary>
!!! Generated from procedure template - Window
!!! Form EMPLOYEE_PROJECT
!!! </summary>
UpdateEMPLOYEE_PROJECT PROCEDURE 

CurrentTab           STRING(80)                            !
ActionMessage        CSTRING(40)                           !
History::EMP2:Record LIKE(EMP2:RECORD),THREAD
QuickWindow          WINDOW('Form EMPLOYEE_PROJECT'),AT(,,163,70),FONT('MS Sans Serif',8,,FONT:regular,CHARSET:DEFAULT), |
  RESIZE,CENTER,GRAY,IMM,MDI,HLP('UpdateEMPLOYEE_PROJECT'),SYSTEM
                       SHEET,AT(4,4,155,44),USE(?CurrentTab)
                         TAB('&1) General'),USE(?Tab:1)
                           PROMPT('EMP NO:'),AT(8,20),USE(?EMP2:EMP_NO:Prompt),TRN
                           ENTRY(@n-7),AT(61,20,40,10),USE(EMP2:EMP_NO)
                           PROMPT('PROJ ID:'),AT(8,34),USE(?EMP2:PROJ_ID:Prompt),TRN
                           ENTRY(@s5),AT(61,34,40,10),USE(EMP2:PROJ_ID)
                         END
                       END
                       BUTTON('&OK'),AT(4,52,49,14),USE(?OK),LEFT,ICON('WAOK.ICO'),DEFAULT,FLAT,MSG('Accept dat' & |
  'a and close the window'),TIP('Accept data and close the window')
                       BUTTON('&Cancel'),AT(57,52,49,14),USE(?Cancel),LEFT,ICON('WACANCEL.ICO'),FLAT,MSG('Cancel operation'), |
  TIP('Cancel operation')
                       BUTTON('&Help'),AT(110,52,49,14),USE(?Help),LEFT,ICON('WAHELP.ICO'),FLAT,MSG('See Help Window'), |
  STD(STD:Help),TIP('See Help Window')
                     END

ThisWindow           CLASS(WindowManager)
Ask                    PROCEDURE(),DERIVED
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
Run                    PROCEDURE(),BYTE,PROC,DERIVED
Run                    PROCEDURE(USHORT Number,BYTE Request),BYTE,PROC,DERIVED
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass
Resizer              CLASS(WindowResizeClass)
Init                   PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)
                     END

CurCtrlFeq          LONG
FieldColorQueue     QUEUE
Feq                   LONG
OldColor              LONG
                    END

  CODE
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------

ThisWindow.Ask PROCEDURE

  CODE
  CASE SELF.Request                                        ! Configure the action message text
  OF ViewRecord
    ActionMessage = 'View Record'
  OF InsertRecord
    ActionMessage = 'Record Will Be Added'
  OF ChangeRecord
    ActionMessage = 'Record Will Be Changed'
  END
  QuickWindow{PROP:Text} = ActionMessage                   ! Display status message in title bar
  PARENT.Ask


ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('UpdateEMPLOYEE_PROJECT')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?EMP2:EMP_NO:Prompt
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  SELF.HistoryKey = CtrlH
  SELF.AddHistoryFile(EMP2:Record,History::EMP2:Record)
  SELF.AddHistoryField(?EMP2:EMP_NO,1)
  SELF.AddHistoryField(?EMP2:PROJ_ID,2)
  SELF.AddUpdateFile(Access:EMPLOYEE_PROJECT)
  SELF.AddItem(?Cancel,RequestCancelled)                   ! Add the cancel control to the window manager
  Relate:EMPLOYEE.Open                                     ! File EMPLOYEE used by this procedure, so make sure it's RelationManager is open
  Relate:EMPLOYEE_PROJECT.Open                             ! File EMPLOYEE_PROJECT used by this procedure, so make sure it's RelationManager is open
  Relate:PROJECT.Open                                      ! File PROJECT used by this procedure, so make sure it's RelationManager is open
  SELF.FilesOpened = True
  SELF.Primary &= Relate:EMPLOYEE_PROJECT
  IF SELF.Request = ViewRecord AND NOT SELF.BatchProcessing ! Setup actions for ViewOnly Mode
    SELF.InsertAction = Insert:None
    SELF.DeleteAction = Delete:None
    SELF.ChangeAction = Change:None
    SELF.CancelAction = Cancel:Cancel
    SELF.OkControl = 0
  ELSE
    SELF.ChangeAction = Change:Caller                      ! Changes allowed
    SELF.CancelAction = Cancel:Cancel+Cancel:Query         ! Confirm cancel
    SELF.OkControl = ?OK
    IF SELF.PrimeUpdate() THEN RETURN Level:Notify.
  END
  SELF.Open(QuickWindow)                                   ! Open window
  Do DefineListboxStyle
  IF SELF.Request = ViewRecord                             ! Configure controls for View Only mode
    ?EMP2:EMP_NO{PROP:ReadOnly} = True
    ?EMP2:PROJ_ID{PROP:ReadOnly} = True
  END
  Resizer.Init(AppStrategy:Surface,Resize:SetMinSize)      ! Controls like list boxes will resize, whilst controls like buttons will move
  SELF.AddItem(Resizer)                                    ! Add resizer to window manager
  INIMgr.Fetch('UpdateEMPLOYEE_PROJECT',QuickWindow)       ! Restore window settings from non-volatile store
  Resizer.Resize                                           ! Reset required after window size altered by INI manager
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:EMPLOYEE.Close
    Relate:EMPLOYEE_PROJECT.Close
    Relate:PROJECT.Close
  END
  IF SELF.Opened
    INIMgr.Update('UpdateEMPLOYEE_PROJECT',QuickWindow)    ! Save window data to non-volatile store
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.Run PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run()
  IF SELF.Request = ViewRecord                             ! In View Only mode always signal RequestCancelled
    ReturnValue = RequestCancelled
  END
  RETURN ReturnValue


ThisWindow.Run PROCEDURE(USHORT Number,BYTE Request)

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run(Number,Request)
  IF SELF.Request = ViewRecord
    ReturnValue = RequestCancelled                         ! Always return RequestCancelled if the form was opened in ViewRecord mode
  ELSE
    GlobalRequest = Request
    EXECUTE Number
      SelectEMPLOYEE
      SelectPROJECT
    END
    ReturnValue = GlobalResponse
  END
  RETURN ReturnValue


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receive all EVENT:Accepted's
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
  ReturnValue = PARENT.TakeAccepted()
    CASE ACCEPTED()
    OF ?EMP2:EMP_NO
      EMP:EMP_NO = EMP2:EMP_NO
      IF Access:EMPLOYEE.TryFetch(EMP:INTEG_27)
        IF SELF.Run(1,SelectRecord) = RequestCompleted
          EMP2:EMP_NO = EMP:EMP_NO
        ELSE
          SELECT(?EMP2:EMP_NO)
          CYCLE
        END
      END
      ThisWindow.Reset(0)
      IF Access:EMPLOYEE_PROJECT.TryValidateField(1)       ! Attempt to validate EMP2:EMP_NO in EMPLOYEE_PROJECT
        SELECT(?EMP2:EMP_NO)
        QuickWindow{PROP:AcceptAll} = False
        CYCLE
      ELSE
        FieldColorQueue.Feq = ?EMP2:EMP_NO
        GET(FieldColorQueue, FieldColorQueue.Feq)
        IF ERRORCODE() = 0
          ?EMP2:EMP_NO{PROP:FontColor} = FieldColorQueue.OldColor
          DELETE(FieldColorQueue)
        END
      END
    OF ?EMP2:PROJ_ID
      PRO:PROJ_ID = EMP2:PROJ_ID
      IF Access:PROJECT.TryFetch(PRO:INTEG_35)
        IF SELF.Run(2,SelectRecord) = RequestCompleted
          EMP2:PROJ_ID = PRO:PROJ_ID
        ELSE
          SELECT(?EMP2:PROJ_ID)
          CYCLE
        END
      END
      ThisWindow.Reset(0)
      IF Access:EMPLOYEE_PROJECT.TryValidateField(2)       ! Attempt to validate EMP2:PROJ_ID in EMPLOYEE_PROJECT
        SELECT(?EMP2:PROJ_ID)
        QuickWindow{PROP:AcceptAll} = False
        CYCLE
      ELSE
        FieldColorQueue.Feq = ?EMP2:PROJ_ID
        GET(FieldColorQueue, FieldColorQueue.Feq)
        IF ERRORCODE() = 0
          ?EMP2:PROJ_ID{PROP:FontColor} = FieldColorQueue.OldColor
          DELETE(FieldColorQueue)
        END
      END
    OF ?OK
      ThisWindow.Update
      IF SELF.Request = ViewRecord AND NOT SELF.BatchProcessing THEN
         POST(EVENT:CloseWindow)
      END
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


Resizer.Init PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)


  CODE
  PARENT.Init(AppStrategy,SetWindowMinSize,SetWindowMaxSize)
  SELF.SetParentDefaults()                                 ! Calculate default control parent-child relationships based upon their positions on the window

!!! <summary>
!!! Generated from procedure template - Window
!!! Form JOB
!!! </summary>
UpdateJOB PROCEDURE 

CurrentTab           STRING(80)                            !
ActionMessage        CSTRING(40)                           !
History::JOB:Record  LIKE(JOB:RECORD),THREAD
QuickWindow          WINDOW('Form JOB'),AT(,,358,140),FONT('MS Sans Serif',8,,FONT:regular,CHARSET:DEFAULT),RESIZE, |
  CENTER,GRAY,IMM,MDI,HLP('UpdateJOB'),SYSTEM
                       SHEET,AT(4,4,350,114),USE(?CurrentTab)
                         TAB('&1) General'),USE(?Tab:1)
                           PROMPT('JOB CODE:'),AT(8,20),USE(?JOB:JOB_CODE:Prompt),TRN
                           ENTRY(@s5),AT(64,20,40,10),USE(JOB:JOB_CODE)
                           PROMPT('JOB GRADE:'),AT(8,34),USE(?JOB:JOB_GRADE:Prompt),TRN
                           ENTRY(@n-7),AT(64,34,40,10),USE(JOB:JOB_GRADE)
                           PROMPT('JOB COUNTRY:'),AT(8,48),USE(?JOB:JOB_COUNTRY:Prompt),TRN
                           ENTRY(@s15),AT(64,48,64,10),USE(JOB:JOB_COUNTRY)
                           PROMPT('JOB TITLE:'),AT(8,62),USE(?JOB:JOB_TITLE:Prompt),TRN
                           ENTRY(@s25),AT(64,62,104,10),USE(JOB:JOB_TITLE)
                           PROMPT('MIN SALARY:'),AT(8,76),USE(?JOB:MIN_SALARY:Prompt),TRN
                           ENTRY(@n-14.2),AT(64,76,64,10),USE(JOB:MIN_SALARY)
                           PROMPT('MAX SALARY:'),AT(8,90),USE(?JOB:MAX_SALARY:Prompt),TRN
                           ENTRY(@n-14.2),AT(64,90,64,10),USE(JOB:MAX_SALARY)
                           PROMPT('LANGUAGE REQ:'),AT(8,104),USE(?JOB:LANGUAGE_REQ:Prompt),TRN
                           ENTRY(@s91),AT(64,104,286,10),USE(JOB:LANGUAGE_REQ)
                         END
                       END
                       BUTTON('&OK'),AT(199,122,49,14),USE(?OK),LEFT,ICON('WAOK.ICO'),DEFAULT,FLAT,MSG('Accept dat' & |
  'a and close the window'),TIP('Accept data and close the window')
                       BUTTON('&Cancel'),AT(252,122,49,14),USE(?Cancel),LEFT,ICON('WACANCEL.ICO'),FLAT,MSG('Cancel operation'), |
  TIP('Cancel operation')
                       BUTTON('&Help'),AT(305,122,49,14),USE(?Help),LEFT,ICON('WAHELP.ICO'),FLAT,MSG('See Help Window'), |
  STD(STD:Help),TIP('See Help Window')
                     END

ThisWindow           CLASS(WindowManager)
Ask                    PROCEDURE(),DERIVED
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
Run                    PROCEDURE(),BYTE,PROC,DERIVED
Run                    PROCEDURE(USHORT Number,BYTE Request),BYTE,PROC,DERIVED
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass
Resizer              CLASS(WindowResizeClass)
Init                   PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)
                     END

CurCtrlFeq          LONG
FieldColorQueue     QUEUE
Feq                   LONG
OldColor              LONG
                    END

  CODE
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------

ThisWindow.Ask PROCEDURE

  CODE
  CASE SELF.Request                                        ! Configure the action message text
  OF ViewRecord
    ActionMessage = 'View Record'
  OF InsertRecord
    ActionMessage = 'Record Will Be Added'
  OF ChangeRecord
    ActionMessage = 'Record Will Be Changed'
  END
  QuickWindow{PROP:Text} = ActionMessage                   ! Display status message in title bar
  PARENT.Ask


ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('UpdateJOB')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?JOB:JOB_CODE:Prompt
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  SELF.HistoryKey = CtrlH
  SELF.AddHistoryFile(JOB:Record,History::JOB:Record)
  SELF.AddHistoryField(?JOB:JOB_CODE,1)
  SELF.AddHistoryField(?JOB:JOB_GRADE,2)
  SELF.AddHistoryField(?JOB:JOB_COUNTRY,3)
  SELF.AddHistoryField(?JOB:JOB_TITLE,4)
  SELF.AddHistoryField(?JOB:MIN_SALARY,5)
  SELF.AddHistoryField(?JOB:MAX_SALARY,6)
  SELF.AddHistoryField(?JOB:LANGUAGE_REQ,7)
  SELF.AddUpdateFile(Access:JOB)
  SELF.AddItem(?Cancel,RequestCancelled)                   ! Add the cancel control to the window manager
  Relate:COUNTRY.Open                                      ! File COUNTRY used by this procedure, so make sure it's RelationManager is open
  Relate:JOB.Open                                          ! File JOB used by this procedure, so make sure it's RelationManager is open
  SELF.FilesOpened = True
  SELF.Primary &= Relate:JOB
  IF SELF.Request = ViewRecord AND NOT SELF.BatchProcessing ! Setup actions for ViewOnly Mode
    SELF.InsertAction = Insert:None
    SELF.DeleteAction = Delete:None
    SELF.ChangeAction = Change:None
    SELF.CancelAction = Cancel:Cancel
    SELF.OkControl = 0
  ELSE
    SELF.ChangeAction = Change:Caller                      ! Changes allowed
    SELF.CancelAction = Cancel:Cancel+Cancel:Query         ! Confirm cancel
    SELF.OkControl = ?OK
    IF SELF.PrimeUpdate() THEN RETURN Level:Notify.
  END
  SELF.Open(QuickWindow)                                   ! Open window
  Do DefineListboxStyle
  IF SELF.Request = ViewRecord                             ! Configure controls for View Only mode
    ?JOB:JOB_CODE{PROP:ReadOnly} = True
    ?JOB:JOB_GRADE{PROP:ReadOnly} = True
    ?JOB:JOB_COUNTRY{PROP:ReadOnly} = True
    ?JOB:JOB_TITLE{PROP:ReadOnly} = True
    ?JOB:MIN_SALARY{PROP:ReadOnly} = True
    ?JOB:MAX_SALARY{PROP:ReadOnly} = True
    ?JOB:LANGUAGE_REQ{PROP:ReadOnly} = True
  END
  Resizer.Init(AppStrategy:Surface,Resize:SetMinSize)      ! Controls like list boxes will resize, whilst controls like buttons will move
  SELF.AddItem(Resizer)                                    ! Add resizer to window manager
  INIMgr.Fetch('UpdateJOB',QuickWindow)                    ! Restore window settings from non-volatile store
  Resizer.Resize                                           ! Reset required after window size altered by INI manager
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:COUNTRY.Close
    Relate:JOB.Close
  END
  IF SELF.Opened
    INIMgr.Update('UpdateJOB',QuickWindow)                 ! Save window data to non-volatile store
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.Run PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run()
  IF SELF.Request = ViewRecord                             ! In View Only mode always signal RequestCancelled
    ReturnValue = RequestCancelled
  END
  RETURN ReturnValue


ThisWindow.Run PROCEDURE(USHORT Number,BYTE Request)

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run(Number,Request)
  IF SELF.Request = ViewRecord
    ReturnValue = RequestCancelled                         ! Always return RequestCancelled if the form was opened in ViewRecord mode
  ELSE
    GlobalRequest = Request
    SelectCOUNTRY
    ReturnValue = GlobalResponse
  END
  RETURN ReturnValue


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receive all EVENT:Accepted's
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
  ReturnValue = PARENT.TakeAccepted()
    CASE ACCEPTED()
    OF ?JOB:JOB_COUNTRY
      COU:COUNTRY = JOB:JOB_COUNTRY
      IF Access:COUNTRY.TryFetch(COU:INTEG_2)
        IF SELF.Run(1,SelectRecord) = RequestCompleted
          JOB:JOB_COUNTRY = COU:COUNTRY
        ELSE
          SELECT(?JOB:JOB_COUNTRY)
          CYCLE
        END
      END
      ThisWindow.Reset(0)
      IF Access:JOB.TryValidateField(3)                    ! Attempt to validate JOB:JOB_COUNTRY in JOB
        SELECT(?JOB:JOB_COUNTRY)
        QuickWindow{PROP:AcceptAll} = False
        CYCLE
      ELSE
        FieldColorQueue.Feq = ?JOB:JOB_COUNTRY
        GET(FieldColorQueue, FieldColorQueue.Feq)
        IF ERRORCODE() = 0
          ?JOB:JOB_COUNTRY{PROP:FontColor} = FieldColorQueue.OldColor
          DELETE(FieldColorQueue)
        END
      END
    OF ?OK
      ThisWindow.Update
      IF SELF.Request = ViewRecord AND NOT SELF.BatchProcessing THEN
         POST(EVENT:CloseWindow)
      END
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


Resizer.Init PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)


  CODE
  PARENT.Init(AppStrategy,SetWindowMinSize,SetWindowMaxSize)
  SELF.SetParentDefaults()                                 ! Calculate default control parent-child relationships based upon their positions on the window

!!! <summary>
!!! Generated from procedure template - Window
!!! Form PHONE_LIST
!!! </summary>
UpdatePHONE_LIST PROCEDURE 

CurrentTab           STRING(80)                            !
ActionMessage        CSTRING(40)                           !
History::PHO:Record  LIKE(PHO:RECORD),THREAD
QuickWindow          WINDOW('Form PHONE_LIST'),AT(,,163,126),FONT('MS Sans Serif',8,,FONT:regular,CHARSET:DEFAULT), |
  RESIZE,CENTER,GRAY,IMM,MDI,HLP('UpdatePHONE_LIST'),SYSTEM
                       SHEET,AT(4,4,155,100),USE(?CurrentTab)
                         TAB('&1) General'),USE(?Tab:1)
                           PROMPT('EMP NO:'),AT(8,20),USE(?PHO:EMP_NO:Prompt),TRN
                           ENTRY(@n-7),AT(61,20,40,10),USE(PHO:EMP_NO)
                           PROMPT('FIRST NAME:'),AT(8,34),USE(?PHO:FIRST_NAME:Prompt),TRN
                           ENTRY(@s15),AT(61,34,64,10),USE(PHO:FIRST_NAME)
                           PROMPT('LAST NAME:'),AT(8,48),USE(?PHO:LAST_NAME:Prompt),TRN
                           ENTRY(@s20),AT(61,48,84,10),USE(PHO:LAST_NAME)
                           PROMPT('PHONE EXT:'),AT(8,62),USE(?PHO:PHONE_EXT:Prompt),TRN
                           ENTRY(@s4),AT(61,62,40,10),USE(PHO:PHONE_EXT)
                           PROMPT('LOCATION:'),AT(8,76),USE(?PHO:LOCATION:Prompt),TRN
                           ENTRY(@s15),AT(61,76,64,10),USE(PHO:LOCATION)
                           PROMPT('PHONE NO:'),AT(8,90),USE(?PHO:PHONE_NO:Prompt),TRN
                           ENTRY(@s20),AT(61,90,84,10),USE(PHO:PHONE_NO)
                         END
                       END
                       BUTTON('&OK'),AT(4,108,49,14),USE(?OK),LEFT,ICON('WAOK.ICO'),DEFAULT,FLAT,MSG('Accept dat' & |
  'a and close the window'),TIP('Accept data and close the window')
                       BUTTON('&Cancel'),AT(57,108,49,14),USE(?Cancel),LEFT,ICON('WACANCEL.ICO'),FLAT,MSG('Cancel operation'), |
  TIP('Cancel operation')
                       BUTTON('&Help'),AT(110,108,49,14),USE(?Help),LEFT,ICON('WAHELP.ICO'),FLAT,MSG('See Help Window'), |
  STD(STD:Help),TIP('See Help Window')
                     END

ThisWindow           CLASS(WindowManager)
Ask                    PROCEDURE(),DERIVED
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
Run                    PROCEDURE(),BYTE,PROC,DERIVED
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass
Resizer              CLASS(WindowResizeClass)
Init                   PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)
                     END

CurCtrlFeq          LONG
FieldColorQueue     QUEUE
Feq                   LONG
OldColor              LONG
                    END

  CODE
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------

ThisWindow.Ask PROCEDURE

  CODE
  CASE SELF.Request                                        ! Configure the action message text
  OF ViewRecord
    ActionMessage = 'View Record'
  OF InsertRecord
    ActionMessage = 'Record Will Be Added'
  OF ChangeRecord
    ActionMessage = 'Record Will Be Changed'
  END
  QuickWindow{PROP:Text} = ActionMessage                   ! Display status message in title bar
  PARENT.Ask


ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('UpdatePHONE_LIST')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?PHO:EMP_NO:Prompt
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  SELF.HistoryKey = CtrlH
  SELF.AddHistoryFile(PHO:Record,History::PHO:Record)
  SELF.AddHistoryField(?PHO:EMP_NO,1)
  SELF.AddHistoryField(?PHO:FIRST_NAME,2)
  SELF.AddHistoryField(?PHO:LAST_NAME,3)
  SELF.AddHistoryField(?PHO:PHONE_EXT,4)
  SELF.AddHistoryField(?PHO:LOCATION,5)
  SELF.AddHistoryField(?PHO:PHONE_NO,6)
  SELF.AddUpdateFile(Access:PHONE_LIST)
  SELF.AddItem(?Cancel,RequestCancelled)                   ! Add the cancel control to the window manager
  Relate:PHONE_LIST.Open                                   ! File PHONE_LIST used by this procedure, so make sure it's RelationManager is open
  SELF.FilesOpened = True
  SELF.Primary &= Relate:PHONE_LIST
  IF SELF.Request = ViewRecord AND NOT SELF.BatchProcessing ! Setup actions for ViewOnly Mode
    SELF.InsertAction = Insert:None
    SELF.DeleteAction = Delete:None
    SELF.ChangeAction = Change:None
    SELF.CancelAction = Cancel:Cancel
    SELF.OkControl = 0
  ELSE
    SELF.ChangeAction = Change:Caller                      ! Changes allowed
    SELF.CancelAction = Cancel:Cancel+Cancel:Query         ! Confirm cancel
    SELF.OkControl = ?OK
    IF SELF.PrimeUpdate() THEN RETURN Level:Notify.
  END
  SELF.Open(QuickWindow)                                   ! Open window
  Do DefineListboxStyle
  IF SELF.Request = ViewRecord                             ! Configure controls for View Only mode
    ?PHO:EMP_NO{PROP:ReadOnly} = True
    ?PHO:FIRST_NAME{PROP:ReadOnly} = True
    ?PHO:LAST_NAME{PROP:ReadOnly} = True
    ?PHO:PHONE_EXT{PROP:ReadOnly} = True
    ?PHO:LOCATION{PROP:ReadOnly} = True
    ?PHO:PHONE_NO{PROP:ReadOnly} = True
  END
  Resizer.Init(AppStrategy:Surface,Resize:SetMinSize)      ! Controls like list boxes will resize, whilst controls like buttons will move
  SELF.AddItem(Resizer)                                    ! Add resizer to window manager
  INIMgr.Fetch('UpdatePHONE_LIST',QuickWindow)             ! Restore window settings from non-volatile store
  Resizer.Resize                                           ! Reset required after window size altered by INI manager
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:PHONE_LIST.Close
  END
  IF SELF.Opened
    INIMgr.Update('UpdatePHONE_LIST',QuickWindow)          ! Save window data to non-volatile store
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.Run PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run()
  IF SELF.Request = ViewRecord                             ! In View Only mode always signal RequestCancelled
    ReturnValue = RequestCancelled
  END
  RETURN ReturnValue


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receive all EVENT:Accepted's
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
  ReturnValue = PARENT.TakeAccepted()
    CASE ACCEPTED()
    OF ?OK
      ThisWindow.Update
      IF SELF.Request = ViewRecord AND NOT SELF.BatchProcessing THEN
         POST(EVENT:CloseWindow)
      END
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


Resizer.Init PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)


  CODE
  PARENT.Init(AppStrategy,SetWindowMinSize,SetWindowMaxSize)
  SELF.SetParentDefaults()                                 ! Calculate default control parent-child relationships based upon their positions on the window

!!! <summary>
!!! Generated from procedure template - Window
!!! Form PROJECT
!!! </summary>
UpdatePROJECT PROCEDURE 

CurrentTab           STRING(80)                            !
ActionMessage        CSTRING(40)                           !
History::PRO:Record  LIKE(PRO:RECORD),THREAD
QuickWindow          WINDOW('Form PROJECT'),AT(,,163,98),FONT('MS Sans Serif',8,,FONT:regular,CHARSET:DEFAULT), |
  RESIZE,CENTER,GRAY,IMM,MDI,HLP('UpdatePROJECT'),SYSTEM
                       SHEET,AT(4,4,155,72),USE(?CurrentTab)
                         TAB('&1) General'),USE(?Tab:1)
                           PROMPT('PROJ ID:'),AT(8,20),USE(?PRO:PROJ_ID:Prompt),TRN
                           ENTRY(@s5),AT(61,20,40,10),USE(PRO:PROJ_ID)
                           PROMPT('PROJ NAME:'),AT(8,34),USE(?PRO:PROJ_NAME:Prompt),TRN
                           ENTRY(@s20),AT(61,34,84,10),USE(PRO:PROJ_NAME)
                           PROMPT('TEAM LEADER:'),AT(8,48),USE(?PRO:TEAM_LEADER:Prompt),TRN
                           ENTRY(@n-7),AT(61,48,40,10),USE(PRO:TEAM_LEADER)
                           PROMPT('PRODUCT:'),AT(8,62),USE(?PRO:PRODUCT:Prompt),TRN
                           ENTRY(@s12),AT(61,62,52,10),USE(PRO:PRODUCT)
                         END
                       END
                       BUTTON('&OK'),AT(4,80,49,14),USE(?OK),LEFT,ICON('WAOK.ICO'),DEFAULT,FLAT,MSG('Accept dat' & |
  'a and close the window'),TIP('Accept data and close the window')
                       BUTTON('&Cancel'),AT(57,80,49,14),USE(?Cancel),LEFT,ICON('WACANCEL.ICO'),FLAT,MSG('Cancel operation'), |
  TIP('Cancel operation')
                       BUTTON('&Help'),AT(110,80,49,14),USE(?Help),LEFT,ICON('WAHELP.ICO'),FLAT,MSG('See Help Window'), |
  STD(STD:Help),TIP('See Help Window')
                     END

ThisWindow           CLASS(WindowManager)
Ask                    PROCEDURE(),DERIVED
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
Run                    PROCEDURE(),BYTE,PROC,DERIVED
Run                    PROCEDURE(USHORT Number,BYTE Request),BYTE,PROC,DERIVED
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass
Resizer              CLASS(WindowResizeClass)
Init                   PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)
                     END

CurCtrlFeq          LONG
FieldColorQueue     QUEUE
Feq                   LONG
OldColor              LONG
                    END

  CODE
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------

ThisWindow.Ask PROCEDURE

  CODE
  CASE SELF.Request                                        ! Configure the action message text
  OF ViewRecord
    ActionMessage = 'View Record'
  OF InsertRecord
    ActionMessage = 'Record Will Be Added'
  OF ChangeRecord
    ActionMessage = 'Record Will Be Changed'
  END
  QuickWindow{PROP:Text} = ActionMessage                   ! Display status message in title bar
  PARENT.Ask


ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('UpdatePROJECT')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?PRO:PROJ_ID:Prompt
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  SELF.HistoryKey = CtrlH
  SELF.AddHistoryFile(PRO:Record,History::PRO:Record)
  SELF.AddHistoryField(?PRO:PROJ_ID,1)
  SELF.AddHistoryField(?PRO:PROJ_NAME,2)
  SELF.AddHistoryField(?PRO:TEAM_LEADER,3)
  SELF.AddHistoryField(?PRO:PRODUCT,4)
  SELF.AddUpdateFile(Access:PROJECT)
  SELF.AddItem(?Cancel,RequestCancelled)                   ! Add the cancel control to the window manager
  Relate:EMPLOYEE.Open                                     ! File EMPLOYEE used by this procedure, so make sure it's RelationManager is open
  Relate:PROJECT.Open                                      ! File PROJECT used by this procedure, so make sure it's RelationManager is open
  SELF.FilesOpened = True
  SELF.Primary &= Relate:PROJECT
  IF SELF.Request = ViewRecord AND NOT SELF.BatchProcessing ! Setup actions for ViewOnly Mode
    SELF.InsertAction = Insert:None
    SELF.DeleteAction = Delete:None
    SELF.ChangeAction = Change:None
    SELF.CancelAction = Cancel:Cancel
    SELF.OkControl = 0
  ELSE
    SELF.ChangeAction = Change:Caller                      ! Changes allowed
    SELF.CancelAction = Cancel:Cancel+Cancel:Query         ! Confirm cancel
    SELF.OkControl = ?OK
    IF SELF.PrimeUpdate() THEN RETURN Level:Notify.
  END
  SELF.Open(QuickWindow)                                   ! Open window
  Do DefineListboxStyle
  IF SELF.Request = ViewRecord                             ! Configure controls for View Only mode
    ?PRO:PROJ_ID{PROP:ReadOnly} = True
    ?PRO:PROJ_NAME{PROP:ReadOnly} = True
    ?PRO:TEAM_LEADER{PROP:ReadOnly} = True
    ?PRO:PRODUCT{PROP:ReadOnly} = True
  END
  Resizer.Init(AppStrategy:Surface,Resize:SetMinSize)      ! Controls like list boxes will resize, whilst controls like buttons will move
  SELF.AddItem(Resizer)                                    ! Add resizer to window manager
  INIMgr.Fetch('UpdatePROJECT',QuickWindow)                ! Restore window settings from non-volatile store
  Resizer.Resize                                           ! Reset required after window size altered by INI manager
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:EMPLOYEE.Close
    Relate:PROJECT.Close
  END
  IF SELF.Opened
    INIMgr.Update('UpdatePROJECT',QuickWindow)             ! Save window data to non-volatile store
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.Run PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run()
  IF SELF.Request = ViewRecord                             ! In View Only mode always signal RequestCancelled
    ReturnValue = RequestCancelled
  END
  RETURN ReturnValue


ThisWindow.Run PROCEDURE(USHORT Number,BYTE Request)

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run(Number,Request)
  IF SELF.Request = ViewRecord
    ReturnValue = RequestCancelled                         ! Always return RequestCancelled if the form was opened in ViewRecord mode
  ELSE
    GlobalRequest = Request
    SelectEMPLOYEE
    ReturnValue = GlobalResponse
  END
  RETURN ReturnValue


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receive all EVENT:Accepted's
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
  ReturnValue = PARENT.TakeAccepted()
    CASE ACCEPTED()
    OF ?PRO:TEAM_LEADER
      EMP:EMP_NO = PRO:TEAM_LEADER
      IF Access:EMPLOYEE.TryFetch(EMP:INTEG_27)
        IF SELF.Run(1,SelectRecord) = RequestCompleted
          PRO:TEAM_LEADER = EMP:EMP_NO
        ELSE
          SELECT(?PRO:TEAM_LEADER)
          CYCLE
        END
      END
      ThisWindow.Reset(0)
      IF Access:PROJECT.TryValidateField(3)                ! Attempt to validate PRO:TEAM_LEADER in PROJECT
        SELECT(?PRO:TEAM_LEADER)
        QuickWindow{PROP:AcceptAll} = False
        CYCLE
      ELSE
        FieldColorQueue.Feq = ?PRO:TEAM_LEADER
        GET(FieldColorQueue, FieldColorQueue.Feq)
        IF ERRORCODE() = 0
          ?PRO:TEAM_LEADER{PROP:FontColor} = FieldColorQueue.OldColor
          DELETE(FieldColorQueue)
        END
      END
    OF ?OK
      ThisWindow.Update
      IF SELF.Request = ViewRecord AND NOT SELF.BatchProcessing THEN
         POST(EVENT:CloseWindow)
      END
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


Resizer.Init PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)


  CODE
  PARENT.Init(AppStrategy,SetWindowMinSize,SetWindowMaxSize)
  SELF.SetParentDefaults()                                 ! Calculate default control parent-child relationships based upon their positions on the window

!!! <summary>
!!! Generated from procedure template - Window
!!! Form PROJ_DEPT_BUDGET
!!! </summary>
UpdatePROJ_DEPT_BUDGET PROCEDURE 

CurrentTab           STRING(80)                            !
ActionMessage        CSTRING(40)                           !
History::PRO2:Record LIKE(PRO2:RECORD),THREAD
QuickWindow          WINDOW('Form PROJ_DEPT_BUDGET'),AT(,,272,112),FONT('MS Sans Serif',8,,FONT:regular,CHARSET:DEFAULT), |
  RESIZE,CENTER,GRAY,IMM,MDI,HLP('UpdatePROJ_DEPT_BUDGET'),SYSTEM
                       SHEET,AT(4,4,264,86),USE(?CurrentTab)
                         TAB('&1) General'),USE(?Tab:1)
                           PROMPT('FISCAL YEAR:'),AT(8,20),USE(?PRO2:FISCAL_YEAR:Prompt),TRN
                           ENTRY(@n-14),AT(80,20,64,10),USE(PRO2:FISCAL_YEAR)
                           PROMPT('PROJ ID:'),AT(8,34),USE(?PRO2:PROJ_ID:Prompt),TRN
                           ENTRY(@s5),AT(80,34,40,10),USE(PRO2:PROJ_ID)
                           PROMPT('DEPT NO:'),AT(8,48),USE(?PRO2:DEPT_NO:Prompt),TRN
                           ENTRY(@s3),AT(80,48,40,10),USE(PRO2:DEPT_NO)
                           PROMPT('QUART HEAD CNT:'),AT(8,62),USE(?PRO2:QUART_HEAD_CNT:Prompt),TRN
                           ENTRY(@s45),AT(80,62,184,10),USE(PRO2:QUART_HEAD_CNT)
                           PROMPT('PROJECTED BUDGET:'),AT(8,76),USE(?PRO2:PROJECTED_BUDGET:Prompt),TRN
                           ENTRY(@n-17.2),AT(80,76,76,10),USE(PRO2:PROJECTED_BUDGET)
                         END
                       END
                       BUTTON('&OK'),AT(113,94,49,14),USE(?OK),LEFT,ICON('WAOK.ICO'),DEFAULT,FLAT,MSG('Accept dat' & |
  'a and close the window'),TIP('Accept data and close the window')
                       BUTTON('&Cancel'),AT(166,94,49,14),USE(?Cancel),LEFT,ICON('WACANCEL.ICO'),FLAT,MSG('Cancel operation'), |
  TIP('Cancel operation')
                       BUTTON('&Help'),AT(219,94,49,14),USE(?Help),LEFT,ICON('WAHELP.ICO'),FLAT,MSG('See Help Window'), |
  STD(STD:Help),TIP('See Help Window')
                     END

ThisWindow           CLASS(WindowManager)
Ask                    PROCEDURE(),DERIVED
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
Run                    PROCEDURE(),BYTE,PROC,DERIVED
Run                    PROCEDURE(USHORT Number,BYTE Request),BYTE,PROC,DERIVED
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass
Resizer              CLASS(WindowResizeClass)
Init                   PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)
                     END

CurCtrlFeq          LONG
FieldColorQueue     QUEUE
Feq                   LONG
OldColor              LONG
                    END

  CODE
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------

ThisWindow.Ask PROCEDURE

  CODE
  CASE SELF.Request                                        ! Configure the action message text
  OF ViewRecord
    ActionMessage = 'View Record'
  OF InsertRecord
    ActionMessage = 'Record Will Be Added'
  OF ChangeRecord
    ActionMessage = 'Record Will Be Changed'
  END
  QuickWindow{PROP:Text} = ActionMessage                   ! Display status message in title bar
  PARENT.Ask


ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('UpdatePROJ_DEPT_BUDGET')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?PRO2:FISCAL_YEAR:Prompt
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  SELF.HistoryKey = CtrlH
  SELF.AddHistoryFile(PRO2:Record,History::PRO2:Record)
  SELF.AddHistoryField(?PRO2:FISCAL_YEAR,1)
  SELF.AddHistoryField(?PRO2:PROJ_ID,2)
  SELF.AddHistoryField(?PRO2:DEPT_NO,3)
  SELF.AddHistoryField(?PRO2:QUART_HEAD_CNT,4)
  SELF.AddHistoryField(?PRO2:PROJECTED_BUDGET,5)
  SELF.AddUpdateFile(Access:PROJ_DEPT_BUDGET)
  SELF.AddItem(?Cancel,RequestCancelled)                   ! Add the cancel control to the window manager
  Relate:DEPARTMENT.Open                                   ! File DEPARTMENT used by this procedure, so make sure it's RelationManager is open
  Relate:PROJECT.Open                                      ! File PROJECT used by this procedure, so make sure it's RelationManager is open
  Relate:PROJ_DEPT_BUDGET.Open                             ! File PROJ_DEPT_BUDGET used by this procedure, so make sure it's RelationManager is open
  SELF.FilesOpened = True
  SELF.Primary &= Relate:PROJ_DEPT_BUDGET
  IF SELF.Request = ViewRecord AND NOT SELF.BatchProcessing ! Setup actions for ViewOnly Mode
    SELF.InsertAction = Insert:None
    SELF.DeleteAction = Delete:None
    SELF.ChangeAction = Change:None
    SELF.CancelAction = Cancel:Cancel
    SELF.OkControl = 0
  ELSE
    SELF.ChangeAction = Change:Caller                      ! Changes allowed
    SELF.CancelAction = Cancel:Cancel+Cancel:Query         ! Confirm cancel
    SELF.OkControl = ?OK
    IF SELF.PrimeUpdate() THEN RETURN Level:Notify.
  END
  SELF.Open(QuickWindow)                                   ! Open window
  Do DefineListboxStyle
  IF SELF.Request = ViewRecord                             ! Configure controls for View Only mode
    ?PRO2:FISCAL_YEAR{PROP:ReadOnly} = True
    ?PRO2:PROJ_ID{PROP:ReadOnly} = True
    ?PRO2:DEPT_NO{PROP:ReadOnly} = True
    ?PRO2:QUART_HEAD_CNT{PROP:ReadOnly} = True
    ?PRO2:PROJECTED_BUDGET{PROP:ReadOnly} = True
  END
  Resizer.Init(AppStrategy:Surface,Resize:SetMinSize)      ! Controls like list boxes will resize, whilst controls like buttons will move
  SELF.AddItem(Resizer)                                    ! Add resizer to window manager
  INIMgr.Fetch('UpdatePROJ_DEPT_BUDGET',QuickWindow)       ! Restore window settings from non-volatile store
  Resizer.Resize                                           ! Reset required after window size altered by INI manager
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:DEPARTMENT.Close
    Relate:PROJECT.Close
    Relate:PROJ_DEPT_BUDGET.Close
  END
  IF SELF.Opened
    INIMgr.Update('UpdatePROJ_DEPT_BUDGET',QuickWindow)    ! Save window data to non-volatile store
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.Run PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run()
  IF SELF.Request = ViewRecord                             ! In View Only mode always signal RequestCancelled
    ReturnValue = RequestCancelled
  END
  RETURN ReturnValue


ThisWindow.Run PROCEDURE(USHORT Number,BYTE Request)

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run(Number,Request)
  IF SELF.Request = ViewRecord
    ReturnValue = RequestCancelled                         ! Always return RequestCancelled if the form was opened in ViewRecord mode
  ELSE
    GlobalRequest = Request
    EXECUTE Number
      SelectPROJECT
      SelectDEPARTMENT
    END
    ReturnValue = GlobalResponse
  END
  RETURN ReturnValue


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receive all EVENT:Accepted's
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
  ReturnValue = PARENT.TakeAccepted()
    CASE ACCEPTED()
    OF ?PRO2:PROJ_ID
      PRO:PROJ_ID = PRO2:PROJ_ID
      IF Access:PROJECT.TryFetch(PRO:INTEG_35)
        IF SELF.Run(1,SelectRecord) = RequestCompleted
          PRO2:PROJ_ID = PRO:PROJ_ID
        ELSE
          SELECT(?PRO2:PROJ_ID)
          CYCLE
        END
      END
      ThisWindow.Reset(0)
      IF Access:PROJ_DEPT_BUDGET.TryValidateField(2)       ! Attempt to validate PRO2:PROJ_ID in PROJ_DEPT_BUDGET
        SELECT(?PRO2:PROJ_ID)
        QuickWindow{PROP:AcceptAll} = False
        CYCLE
      ELSE
        FieldColorQueue.Feq = ?PRO2:PROJ_ID
        GET(FieldColorQueue, FieldColorQueue.Feq)
        IF ERRORCODE() = 0
          ?PRO2:PROJ_ID{PROP:FontColor} = FieldColorQueue.OldColor
          DELETE(FieldColorQueue)
        END
      END
    OF ?PRO2:DEPT_NO
      DEP:DEPT_NO = PRO2:DEPT_NO
      IF Access:DEPARTMENT.TryFetch(DEP:INTEG_16)
        IF SELF.Run(2,SelectRecord) = RequestCompleted
          PRO2:DEPT_NO = DEP:DEPT_NO
        ELSE
          SELECT(?PRO2:DEPT_NO)
          CYCLE
        END
      END
      ThisWindow.Reset(0)
      IF Access:PROJ_DEPT_BUDGET.TryValidateField(3)       ! Attempt to validate PRO2:DEPT_NO in PROJ_DEPT_BUDGET
        SELECT(?PRO2:DEPT_NO)
        QuickWindow{PROP:AcceptAll} = False
        CYCLE
      ELSE
        FieldColorQueue.Feq = ?PRO2:DEPT_NO
        GET(FieldColorQueue, FieldColorQueue.Feq)
        IF ERRORCODE() = 0
          ?PRO2:DEPT_NO{PROP:FontColor} = FieldColorQueue.OldColor
          DELETE(FieldColorQueue)
        END
      END
    OF ?OK
      ThisWindow.Update
      IF SELF.Request = ViewRecord AND NOT SELF.BatchProcessing THEN
         POST(EVENT:CloseWindow)
      END
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


Resizer.Init PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)


  CODE
  PARENT.Init(AppStrategy,SetWindowMinSize,SetWindowMaxSize)
  SELF.SetParentDefaults()                                 ! Calculate default control parent-child relationships based upon their positions on the window

!!! <summary>
!!! Generated from procedure template - Window
!!! Form SALARY_HISTORY
!!! </summary>
UpdateSALARY_HISTORY PROCEDURE 

CurrentTab           STRING(80)                            !
ActionMessage        CSTRING(40)                           !
History::SAL:Record  LIKE(SAL:RECORD),THREAD
QuickWindow          WINDOW('Form SALARY_HISTORY'),AT(,,192,140),FONT('MS Sans Serif',8,,FONT:regular,CHARSET:DEFAULT), |
  RESIZE,CENTER,GRAY,IMM,MDI,HLP('UpdateSALARY_HISTORY'),SYSTEM
                       SHEET,AT(4,4,184,114),USE(?CurrentTab)
                         TAB('&1) General'),USE(?Tab:1)
                           PROMPT('EMP NO:'),AT(8,20),USE(?SAL:EMP_NO:Prompt),TRN
                           ENTRY(@n-7),AT(80,20,40,10),USE(SAL:EMP_NO)
                           PROMPT('CHANGE DATE DATE:'),AT(8,34),USE(?SAL:CHANGE_DATE_DATE:Prompt),TRN
                           ENTRY(@d17),AT(80,34,104,10),USE(SAL:CHANGE_DATE_DATE)
                           PROMPT('CHANGE DATE TIME:'),AT(8,48),USE(?SAL:CHANGE_DATE_TIME:Prompt),TRN
                           ENTRY(@t7),AT(80,48,104,10),USE(SAL:CHANGE_DATE_TIME)
                           PROMPT('UPDATER ID:'),AT(8,62),USE(?SAL:UPDATER_ID:Prompt),TRN
                           ENTRY(@s20),AT(80,62,84,10),USE(SAL:UPDATER_ID)
                           PROMPT('OLD SALARY:'),AT(8,76),USE(?SAL:OLD_SALARY:Prompt),TRN
                           ENTRY(@n-14.2),AT(80,76,64,10),USE(SAL:OLD_SALARY)
                           PROMPT('PERCENT CHANGE:'),AT(8,90),USE(?SAL:PERCENT_CHANGE:Prompt),TRN
                           ENTRY(@n10.2),AT(80,90,44,10),USE(SAL:PERCENT_CHANGE)
                           PROMPT('NEW SALARY:'),AT(8,104),USE(?SAL:NEW_SALARY:Prompt),TRN
                           ENTRY(@n10.2),AT(80,104,44,10),USE(SAL:NEW_SALARY)
                         END
                       END
                       BUTTON('&OK'),AT(33,122,49,14),USE(?OK),LEFT,ICON('WAOK.ICO'),DEFAULT,FLAT,MSG('Accept dat' & |
  'a and close the window'),TIP('Accept data and close the window')
                       BUTTON('&Cancel'),AT(86,122,49,14),USE(?Cancel),LEFT,ICON('WACANCEL.ICO'),FLAT,MSG('Cancel operation'), |
  TIP('Cancel operation')
                       BUTTON('&Help'),AT(139,122,49,14),USE(?Help),LEFT,ICON('WAHELP.ICO'),FLAT,MSG('See Help Window'), |
  STD(STD:Help),TIP('See Help Window')
                     END

ThisWindow           CLASS(WindowManager)
Ask                    PROCEDURE(),DERIVED
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
Run                    PROCEDURE(),BYTE,PROC,DERIVED
Run                    PROCEDURE(USHORT Number,BYTE Request),BYTE,PROC,DERIVED
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass
Resizer              CLASS(WindowResizeClass)
Init                   PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)
                     END

CurCtrlFeq          LONG
FieldColorQueue     QUEUE
Feq                   LONG
OldColor              LONG
                    END

  CODE
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------

ThisWindow.Ask PROCEDURE

  CODE
  CASE SELF.Request                                        ! Configure the action message text
  OF ViewRecord
    ActionMessage = 'View Record'
  OF InsertRecord
    ActionMessage = 'Record Will Be Added'
  OF ChangeRecord
    ActionMessage = 'Record Will Be Changed'
  END
  QuickWindow{PROP:Text} = ActionMessage                   ! Display status message in title bar
  PARENT.Ask


ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('UpdateSALARY_HISTORY')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?SAL:EMP_NO:Prompt
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  SELF.HistoryKey = CtrlH
  SELF.AddHistoryFile(SAL:Record,History::SAL:Record)
  SELF.AddHistoryField(?SAL:EMP_NO,1)
  SELF.AddHistoryField(?SAL:CHANGE_DATE_DATE,4)
  SELF.AddHistoryField(?SAL:CHANGE_DATE_TIME,5)
  SELF.AddHistoryField(?SAL:UPDATER_ID,6)
  SELF.AddHistoryField(?SAL:OLD_SALARY,7)
  SELF.AddHistoryField(?SAL:PERCENT_CHANGE,8)
  SELF.AddHistoryField(?SAL:NEW_SALARY,9)
  SELF.AddUpdateFile(Access:SALARY_HISTORY)
  SELF.AddItem(?Cancel,RequestCancelled)                   ! Add the cancel control to the window manager
  Relate:EMPLOYEE.Open                                     ! File EMPLOYEE used by this procedure, so make sure it's RelationManager is open
  Relate:SALARY_HISTORY.Open                               ! File SALARY_HISTORY used by this procedure, so make sure it's RelationManager is open
  SELF.FilesOpened = True
  SELF.Primary &= Relate:SALARY_HISTORY
  IF SELF.Request = ViewRecord AND NOT SELF.BatchProcessing ! Setup actions for ViewOnly Mode
    SELF.InsertAction = Insert:None
    SELF.DeleteAction = Delete:None
    SELF.ChangeAction = Change:None
    SELF.CancelAction = Cancel:Cancel
    SELF.OkControl = 0
  ELSE
    SELF.ChangeAction = Change:Caller                      ! Changes allowed
    SELF.CancelAction = Cancel:Cancel+Cancel:Query         ! Confirm cancel
    SELF.OkControl = ?OK
    IF SELF.PrimeUpdate() THEN RETURN Level:Notify.
  END
  SELF.Open(QuickWindow)                                   ! Open window
  Do DefineListboxStyle
  IF SELF.Request = ViewRecord                             ! Configure controls for View Only mode
    ?SAL:EMP_NO{PROP:ReadOnly} = True
    ?SAL:CHANGE_DATE_DATE{PROP:ReadOnly} = True
    ?SAL:CHANGE_DATE_TIME{PROP:ReadOnly} = True
    ?SAL:UPDATER_ID{PROP:ReadOnly} = True
    ?SAL:OLD_SALARY{PROP:ReadOnly} = True
    ?SAL:PERCENT_CHANGE{PROP:ReadOnly} = True
    ?SAL:NEW_SALARY{PROP:ReadOnly} = True
  END
  Resizer.Init(AppStrategy:Surface,Resize:SetMinSize)      ! Controls like list boxes will resize, whilst controls like buttons will move
  SELF.AddItem(Resizer)                                    ! Add resizer to window manager
  INIMgr.Fetch('UpdateSALARY_HISTORY',QuickWindow)         ! Restore window settings from non-volatile store
  Resizer.Resize                                           ! Reset required after window size altered by INI manager
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:EMPLOYEE.Close
    Relate:SALARY_HISTORY.Close
  END
  IF SELF.Opened
    INIMgr.Update('UpdateSALARY_HISTORY',QuickWindow)      ! Save window data to non-volatile store
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.Run PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run()
  IF SELF.Request = ViewRecord                             ! In View Only mode always signal RequestCancelled
    ReturnValue = RequestCancelled
  END
  RETURN ReturnValue


ThisWindow.Run PROCEDURE(USHORT Number,BYTE Request)

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run(Number,Request)
  IF SELF.Request = ViewRecord
    ReturnValue = RequestCancelled                         ! Always return RequestCancelled if the form was opened in ViewRecord mode
  ELSE
    GlobalRequest = Request
    SelectEMPLOYEE
    ReturnValue = GlobalResponse
  END
  RETURN ReturnValue


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receive all EVENT:Accepted's
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
  ReturnValue = PARENT.TakeAccepted()
    CASE ACCEPTED()
    OF ?SAL:EMP_NO
      EMP:EMP_NO = SAL:EMP_NO
      IF Access:EMPLOYEE.TryFetch(EMP:INTEG_27)
        IF SELF.Run(1,SelectRecord) = RequestCompleted
          SAL:EMP_NO = EMP:EMP_NO
        ELSE
          SELECT(?SAL:EMP_NO)
          CYCLE
        END
      END
      ThisWindow.Reset(0)
      IF Access:SALARY_HISTORY.TryValidateField(1)         ! Attempt to validate SAL:EMP_NO in SALARY_HISTORY
        SELECT(?SAL:EMP_NO)
        QuickWindow{PROP:AcceptAll} = False
        CYCLE
      ELSE
        FieldColorQueue.Feq = ?SAL:EMP_NO
        GET(FieldColorQueue, FieldColorQueue.Feq)
        IF ERRORCODE() = 0
          ?SAL:EMP_NO{PROP:FontColor} = FieldColorQueue.OldColor
          DELETE(FieldColorQueue)
        END
      END
    OF ?OK
      ThisWindow.Update
      IF SELF.Request = ViewRecord AND NOT SELF.BatchProcessing THEN
         POST(EVENT:CloseWindow)
      END
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


Resizer.Init PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)


  CODE
  PARENT.Init(AppStrategy,SetWindowMinSize,SetWindowMaxSize)
  SELF.SetParentDefaults()                                 ! Calculate default control parent-child relationships based upon their positions on the window

